16/07/97 21:25:45
   
notFullyImplemented
    "Alert the user because the method
     has not been fully implemented yet..."
    #addedByOStyle.
    MessageBox warning: 'Not Fully implemented.\Yet...' withCrs!   
platformDependent
    "Private - This selector will be included in all methods
    added by Object Style that are dependent to version
    and in case of porting (&down porting) MUST be revised...

    Smalltalk sendersOf: #platformDependent

    "

    #addedByOStyle.!   
addedByOStyle
    "Private - This selector will be included in all methods
    added by Object Style.

    Smalltalk sendersOf: #addedByOStyle

    "

    #addedByOStyle.!   
modifiedByOStyle
    "Private - This selector will be included in all methods
    modified by Object Style.

    Smalltalk sendersOf: #modifiedByOStyle.
    "

    #addedOStyle.! 
fileOutOn: aStream
    "Permorms fileOut of all the proyect.
    Created by Ale Jul  8, 1991"

    | class file stream |

     "Do default fileOut"
    (aStream isKindOf: FileStream)
        ifFalse: [^self basicFileOutOn: aStream ].
    ((self sourcesCollection includes: aStream)    "change.log or sources.sml"
      or: [ self == ProjectClasses])  "fileOut default if self"
    ifTrue: [^self basicFileOutOn: aStream ]. "done..."

    "Perform pools dictionary fileOuts if the receiver wants to"
    self hasPoolDictionaries
    ifTrue: [
        file := File newFile: self abreviation,'.Pol'.
        self fileOutDictionariesInto: file.
        file close
    ].

    "Do fileOut for dependents proyects"
    self dependentProjects do: [:each| each fileOutNow].

    self preConditions size = 0
    ifFalse: [
        aStream nextChunkPut: self preConditions
    ].

    "Do dependent classes fileOut"
    self dependentClasses do: [:peach|
        aStream cr.
        peach fileOutOn: aStream.
        aStream nextChunkPut: String new.
		peach class instanceVariableString isEmpty
        ifFalse: [
            aStream cr; cr.
            peach class fileOutOn: aStream.
            aStream nextChunkPut: String new.
		].
    ].
    self dependentClasses do: [:each|
        each class selectors isEmpty
        ifFalse: [
            (self classReader forClass: each class) fileOutOn: aStream
        ].
         each selectors isEmpty
        ifFalse: [ (self classReader forClass: each) fileOutOn: aStream ]
    ].

    "Do dependent methods fileOut"
    self dependentMethods associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        aStream setToEnd;cr;cr;
            nextPut: $!!;
            nextPutAll: ' ',class name , ' methods !!'.
        asoc value do: [:selector|
			stream := ReadStream on: (class compiledMethodAt: selector) sourceString.
			stream atEnd ifFalse: [
	            aStream cr.
				[stream atEnd] whileFalse: [ aStream nextPutAll: (stream upTo: $!!) ].
   	            aStream nextPut: $!!
			].
        ].
        aStream nextPutAll: ' !!'.
    ].

    "Do project fileOut"
    self basicFileOut.!
postConditions
    "Private  - Returns source needed for postloading this proyect"

    ^String new!   
methodsCollection
    "Private - Returns the Project dependent methods as array of methodsNames subarrays.
    This method can be refined by subclasses.
e.g.:
    ^#(
         Object (notImplementedYet notFullyImplemented)
        )
        ,(Array with: CursorManager class with: #(fromModule:id: ))
    "

    ^Array new! 
sourcesCollection
    "Private - Returns the Sources collection."

	^Smalltalk at: #Sources
		ifAbsent: [
			self
				checkBound: 'vdev31w'; "development support"
				yourself.
			Smalltalk at: #Sources
		]!  
buildSLL: withSource
    "Build a Smalltalk Library with the receiver's dependents."

    | builder class |
    builder := self smalltalkLibraryBuilder new.

    builder
        fileName: (self fileName: self abreviation extension: 'SLL');
        windowFeedback;
        sourceSeparate;
        yourself.
	self startBuildingSLL: builder.

	self comment size > 0 ifTrue: [ builder description: self comment ].

    "Do build for dependents proyects.
    self dependentProjects do: [:each| each buildSLL: withSource ].
    "

    "Perform pools dictionary registration if the receiver wants to"
    self hasPoolDictionaries
    ifTrue: [
        self poolDictionaryNames do: [:aPool|
            builder addGlobalNamed: aPool
        ].
    ].

    "Perform class registration."
    self dependentClasses do: [:aClass|
		self prepareForSLLBuild: aClass.
		builder addClass: aClass
	].
    self mustBeEmbededInSLL ifTrue: [
        builder addClass: self.
        self mustBeInitializedWhenLoading
        ifTrue: [
            builder bindAction: (Message receiver: self selector: #initialize)
        ].
        self hasUnBindMethod
        ifTrue: [
            builder unBindAction: (Message receiver: self selector: #unBind)
        ].
    ]
	ifFalse: [
		self buildProjectSLL: withSource
	].

    "Perform methods registration."
    self dependentMethods associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        asoc value do: [:selector|
            builder
                addMethod: (class compiledMethodAt: selector)
                includeSource: withSource
        ].
    ].

	self endBuildingSLL: builder.
    builder
        includeSource: withSource;
        writeFile.!  
fileOutNow
    "FileOut of the receiver in default file (fileName is detemined with the proyect abreviation and .St extension)"

    | file |
    CursorManager execute changeFor: [
        file := Disk newFile: (self fileName: self abreviation extension: 'St').
        file  lineDelimiter: Cr.
        self fileOutOn: file.
        file close.
    ].! 
destroyUnusedPoolEntries: pools
    "Private - Destroy  unused PoolDictionary entries if the user wants to."

    | inUse collect poolDict |

    "Prompt the user..."
    (MessageBox confirm:
        'Do you want to destroy unused PoolDictionary entries ?\' withCrs,
        pools printString) ifFalse: [^nil].

    "Collect the used associations in a class method..."
    collect := [:methods|
        methods do: [:method|
            method do: [:literal|
                literal isAssociation
                ifTrue: [ inUse add: literal ]
            ]
        ]
    ].

    "Collect all associations in the receiver's classes..."
    inUse := Set new.
    self dependentClasses asArray
    do: [:cls|
        (cls sharedPools
        detect: [:pool| pools includes: pool ]
        ifNone: []) notNil
        ifTrue: [
            collect
                value: cls compiledMethods values;
                value: cls class compiledMethods values
        ]
    ].

    "Remove unused entries..."
    pools do: [:aPoolName|
        poolDict := Smalltalk at: aPoolName ifAbsent: [].
        poolDict keys do: [:aKey|
            (inUse includes: (poolDict associationAt: aKey))
            ifFalse: [ poolDict removeKey: aKey ]
        ]
    ].!  
endBuildingSLL: aSmalltalkLibraryBuilder
    " Private - The receiver will write the project onto a aSmalltalkLibraryBuilder.
	The default action is to do nothing.
	This method can be refined by subclasses..."! 
destroyGlobalReferences
    "Private - Destroy all the proyect global variables references.
    Used during proyect destruction.
        e.g. : Smalltalk at: #ProxyServers put: nil.
        Smalltalk removeKey: #ProxyServers.
    This method can be refined by subclasses."

    "Default action is to remove unused PoolDictionary entries if the user wants to."
    | pools |
    self hasPoolDictionaries ifFalse: [^self].
    pools := self poolDictionaryNames.
    pools isEmpty ifTrue: [^self].
    self destroyUnusedPoolEntries: pools.! 
destroySources
    "Destroy all the proyect sources."

    | class |
    (MessageBox confirm: 'Do you want to destroy \sources of ' withCrs, self name,' ?') ifFalse: [^nil].
    self dependentMethods
    associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        asoc value do: [:selector| class removeSourcesOfSelector: selector].
    ].
    self dependentClasses asArray reversed do: [:each| each removeSources].!  
details
    "Returns aString with the details
     of each dependent class extracted
     from it's sources.
    Ussefull as
        SolerProject details outputToPrinter
    "

    ^self details:
        (MessageBox confirm: ('Do you want the Private details \ for '
                    ,self name,' ?') withCrs)!   
details: withPrivates
    "Returns aString with the details
     of each dependent class extracted
     from it's sources.
    Ussefull as
        (SolerProject details: false) outputToPrinter
    "

    | stream detail getComment getName process src |
    stream := WriteStream on: String new.
    getComment := [:aStream |
        aStream atEnd
        ifFalse: [aStream upTo: $";next;upTo: $".
            aStream atEnd ifFalse: [aStream next]
        ].
        aStream
    ].
    getName := [:sourceStream|
        [
            [sourceStream peek isSeparator] whileTrue: [sourceStream next].
            (sourceStream atEnd or: [sourceStream peek = $"])]
         whileFalse: [sourceStream nextWord].
        sourceStream
    ].
    detail := [:source |
        source size = 0
        ifFalse: [
            source copyFrom: 1
                to: (getComment value: (getName value: source asStream)) position
        ] ifTrue: [String new]
    ].

    process := [:aClass|
        stream cr;nextPutAll: aClass name,' details !!'.
        aClass selectors asSortedCollection
        do: [:aSymbol|
            src := (detail value: (aClass compiledMethodAt: aSymbol) sourceString).
            (withPrivates not and: [(src indexOfCollection: 'Private -') > 0]) ifTrue: [src := nil].
            src size = 0 ifFalse: [stream cr;nextPutAll: src].
        ]
    ].

    self dependentClasses do: [:class|
        stream cr.
        class fileOutOn: stream.
        stream cr.
        process value: class class; value: class.
    ].
    ^stream contents!
fileName: aFileName extension: extension
    "Private - Adapt aFileName & extension to host file name."

    | fileName |
    (OperatingSystem isWindows95 or: [OperatingSystem isWindowsNT])
	ifTrue: [ "leave unchanged..."
		^extension isNil ifTrue: [aFileName]
			ifFalse: [ aFileName,'.',extension ]
	].
	^File fileName: aFileName extension: extension!
smalltalkLibraryBuilder
    "Private - Returns the Smalltalk Library Builder support class."

    ^Smalltalk at: #SmalltalkLibraryBuilder
        ifAbsent: [
            self
                checkBound: 'vosw31'; "ObjectStore support"
                checkBound: 'vslb31'; "LibraryBuilder support"
                yourself.
            Smalltalk at: #SmalltalkLibraryBuilder
        ]!   
nonRemovableMethodsCollection
    "Private - Returns the Project dependent methods that must not be removed
     for general classes as array of methodsNames subarrays.
    This method can be refined by subclasses"

    ^#( "Default methods table"
            Object (notImplementedYet notFullyImplemented)
        )!  
author
    "Private - Returns the receiver's author name.
    This method can be refined by subclasses"

    ^'Alejandro F. Reimondo'!
author: aString
    "Set the author of the receiver."

    self compileSource: 'author
    "Returns the author name for the receiver."

    ^', aString storeString!
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be refined by subclasses"

    ^false!  
nonRemovableMethods
    "Private - Returns the Project dependent methods that must not been removed."

    | result stream |
    result := Dictionary new.
    stream := ReadStream on: self nonRemovableMethodsCollection.
    [stream atEnd] whileFalse: [ result at: stream next put: stream next ].
    ^result!   
headers
    "Returns aString with the class headers of the proyect.
        Ussefull as
             SolerProject headers edit
    "

   | stream |
    stream := WriteStream on: (String new: 1000).
    stream
        cr;space;
        nextPutAll: self class name,' headers.';
        cr;cr.
    self dependentClasses
     do: [:class| class fileOutOn: stream. stream cr ].
    ^stream contents!  
missingClass: aSymbol
    "Private - A class named aSymbol has been missed.
     Returns nil for no error generation."

	(MessageBox confirm: 'Class ', aSymbol,' is missing.\Continue ?' withCrs)
    ifFalse: [ ^self error: 'Class missing ',aSymbol ].
    ^nil!
initialize
    "Initializes the receiver. When the proyect is filledIn,
     It is automatically initialized if it's wanted in postCondition.
    Default initialization code do nothing..."

    "
        Smalltalk at: #ProxyServers put: ProxyServersCollection new.
    "!
preConditions
    "Private  - Returns source needed for preloading this proyect"

    ^'"
    __________________________________________________
    ',self copyright,' ', Date today printString,'
    This proyect sources are property of : ',self author,'
    Its use is NOT legal without written rights.
    ',self address,'
    __________________________________________________
"',
    (self hasPoolDictionaries ifTrue: ['
    (File pathName: ''',self abreviation,'.Pol'') fileIn;close.
'] ifFalse: [String new])!  
addClass: aClass
    "Add a new class to the list of dependent classes."

    | source cole stream cls toRemove generateCode |
    self == ProjectClasses ifTrue: [^self invalidMessage].

    cole := self classNames asSet asOrderedCollection.
    toRemove := Set new.
    cole do: [:each| "eliminate redundances..."
        cls := Smalltalk at: each ifAbsent: [each].
        (aClass inheritsFrom: cls) ifTrue: [^self]. "done..."
        (cls inheritsFrom: aClass) ifTrue: [toRemove add: each].
    ].
    cole removeAll: toRemove. "remove dependent classes..."
    cole add: (aClass isClass ifTrue: [aClass symbol ] ifFalse: [aClass]).

    "code generation block for class descriptions"
    generateCode := [:aCls|
        aCls isSymbol
        ifTrue: [source space;nextPutAll: aCls]
        ifFalse: [source nextPutAll: '),(Array with: ',aCls printString,'),#(']
    ].

    source := ReadWriteStream on: String new.
    source nextPutAll: 'classNames
    "Private - Return the names of Project dependent classes."

    ^#('.
    stream := ReadStream on: cole asArray.
    [stream atEnd] whileFalse: [
        source cr;next: 4 put: $ .
        4 timesRepeat: [ stream atEnd ifFalse: [
            generateCode value: stream next
        ]]
    ].
    source nextPutAll: ' )'.

    self compileSource: source contents.!   
basicFileOutOn: aStream
    "Performs fileOut of the receiver without aditional code."

    ^super fileOutOn: aStream! 
destroyOtherSources
    "Destroy all the non proyect sources."

    | class dontRemove methods classes dependentClasses |
    (MessageBox confirm:
        'Do you want to destroy \ALL the sources except\' withCrs
			,' sources of ', self name,' ?' )
    ifFalse: [^nil].
    dontRemove := Set new.
    self dependentMethods
    associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        asoc value do: [:selector|
            dontRemove add: (class compiledMethodAt: selector)
        ].
    ].

    methods := Smalltalk methodsInLOG.
    dontRemove do: [:each| methods remove: each ifAbsent: []].
    classes := Set new.
    dependentClasses := self dependentClasses.
    methods copy do: [:each|
        (dependentClasses includes: each classField)
        ifTrue: [methods remove: each ifAbsent: []]
    ].

    (MessageBox confirm: 'Do you want to save the removed sources ?' withCrs)
    ifTrue: [ (self saveOtherSources: methods) isNil ifTrue: [^nil] ].
    (MessageBox confirm:
        'Last Chance !!\Do you really want to destroy \ALL the sources except\' withCrs
            ,' sources of ', self name,' ?' withCrs)
    ifFalse: [^nil].

    methods do: [:method|
        method classField removeSourcesOfSelector: method selector
    ].!
addMethod: aMethod
    "Add a new method to the list of dependent methods."

    | source dict generateCode aClass |
    self == ProjectClasses ifTrue: [^self invalidMessage].

    dict := self dependentMethods.

    aClass := aMethod classField.
    aClass := aClass isClass ifTrue: [aClass symbol] ifFalse: [aClass].
    dict at: aClass put:
        (dict at: aClass ifAbsent: [#()]) asArray, (Array with: aMethod selector).

    "code generation block for class descriptions"
    generateCode := [:aCls :aCole|
        aClass := aCls isSymbol
        ifTrue: [Smalltalk at: aCls ifAbsent: [self missingClass: aCls. nil]]
        ifFalse: [aCls].
        aClass isNil ifTrue: [^nil]. "exit now..."
        aCls isSymbol
        ifTrue: [source nextPutAll: aCls;space]
        ifFalse: [source nextPutAll: '),(Array with: ',aCls printString,'),#( '].
        source nextPutAll: aCole asArray printString
    ].

    source := ReadWriteStream on: (String new: 3000).
    source nextPutAll: 'methodsCollection
    "Private - Returns the Project dependent methods for general classes as array of methodsNames subarrays."

    ^#('.
    dict associationsDo: [:asoc|
        source cr;next: 4 put: $ .
        generateCode value: asoc key value: asoc value
    ].
    source nextPutAll: ' )'.

    self compileSource: source contents.!   
mustBeEmbededInSLL
    "Private - Returns true if the receiver must be included within it's parts.
	This affects receiver's dependences when loading.
    Default action is to answer true for automatic embedding.
    This method can be refined by subclasses"

    ^false "if true the SLL will need ARBase.SLL for ProjectClasses support"!
startBuildingSLL: aSmalltalkLibraryBuilder
    " Private - The receiver will start to build the project onto a aSmalltalkLibraryBuilder.
	The default action is to do nothing.
	This method can be refined by subclasses..."

	"Example to purge DLL classes in use...

	super startBuildingSLL: aSmalltalkLibraryBuilder.
	aSmalltalkLibraryBuilder
		bindAction: (Message
			receiver: MyDLLCurrentlyInUse
			selector: #current:
			arguments: (Array with: nil))
	"! 
destroy
    "Destroy all the proyect."

    | class toRemove |
    (MessageBox confirm: 'Do you want to destroy ', self name,' ?') ifFalse: [^nil].

    toRemove := self dependentMethods.
    self nonRemovableMethods
        associationsDo: [:asoc|
            (toRemove includesKey: asoc key)
            ifTrue: [
                asoc value do: [:each|
                    (toRemove at: asoc key) remove: each ifAbsent: []
                ]
            ]
        ].

    toRemove associationsDo: [:asoc|
            class := Smalltalk at: asoc key ifAbsent: [asoc key].
            asoc value do: [:selector| class removeSelector: selector]
    ].

    self destroyGlobalReferences.
    self dependentClasses asArray reversed
    do: [:each|
        class := Smalltalk at: each ifAbsent: [each].
        class selectors do: [:selector| class removeSelector: selector].
        class isMetaClass
        ifFalse: [
            class instVarNames atAllPut: 'x'. "destroy instances names"
            class classPool keys do: [:key| class classPool removeKey: key]. "destroy class var names"
            class sharedPools do: [:key| class removeSharedPool: key ]. "destroy shared pools references"
            class class selectors do: [:selector| class class removeSelector: selector].
        ]
    ].

    (MessageBox confirm: 'Remove the classes from system?')
    ifTrue: [
        self dependentClasses asArray reversed
        do: [:each| each removeFromSystem].
        self removeFromSystem.
    ].

    class := nil.! 
compileSource: source
    "Private - Compile and Log the source code in 'source' "

    | result |
    (result := self class compile: source trimBlanks) isNil
     ifTrue: [^self error: 'Error during code generation...'].

    self sourceManager current
        logSource: source trimBlanks
        forSelector: result key
        inClass: self class! 
sourceManager
    "Private - Returns the source manager support class."

	^Smalltalk at: #SourceManager
		ifAbsent: [
			self
				checkBound: 'vdev31w'; "development support"
				yourself.
			Smalltalk at: #SourceManager
		]!
basicFileOut
    "FileOut of the receiver for basic instalation.
    Warning: The source file will be a project(.Prj) file."

    | file classes |
    CursorManager execute changeFor: [
        file := Disk newFile:
            (self fileName: self abreviation extension: 'Prj').
        file  lineDelimiter: Cr.

        classes := Array "with: ProjectClasses" with: self.
        classes
        do: [:each|
            each basicFileOutOn: file.
            file nextChunkPut: String new.
        ].
        classes do: [:each|
            each class selectors notEmpty ifTrue: [
				(self classReader forClass: each class) fileOutOn: file
			].
            each selectors notEmpty ifTrue: [
				(self classReader forClass: each) fileOutOn: file.
			].
        ].

	    self mustBeInitializedWhenLoading
		ifTrue: [ file nextChunkPut: self name,' initialize.' ].

        file close.
    ].!   
classReader
    "Private - Returns the class reader support class."

	^Smalltalk at: #ClassReader
		ifAbsent: [
			self
				checkBound: 'vdev31w'; "development support"
				yourself.
			Smalltalk at: #ClassReader
		]!
proyectNames
    "Returns the names of dependent proyects.
    Default answer is empty.
    This method can be refined by subclasses."

    ^Array new!  
missingProject: aSymbol
    "Private - A proyect named aSymbol has been missed.
     Returns nil for no error generation."

	(MessageBox confirm: 'Project ', aSymbol,' is missing.\Continue ?' withCrs)
    ifFalse: [ ^self error: 'Project missing ',aSymbol ].
    ^nil!
buildSLL
    "Build a Smalltalk Library with this project with sourceCode included."

    ^self buildSLL: true!
comment
	" Documentation - Returns the receiver's comment string.
	This method can be refined by subclasses... "

	^nil!  
prepareForSLLBuild: anObject
    "Private - Prepare anObject to be packaged onto an SLL.
	WARNING: The current instance of DLL classes is cleared prior to be dounloaded, to destroy obsolete references.
	This method can be refined by subclasses."

    (anObject isBehavior
	and: [ (anObject allSuperclasses includes: DynamicLinkLibrary)
	and: [ anObject currentOrNil notNil ]])
	ifTrue: [
		anObject
			clearCachedAddresses;
			current: nil;
			yourself
	].!
address
    "Private - Returns the receiver's author address.
    This method can be refined by subclasses."

    ^'Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.'!   
address: aString
    "Set the address of the receiver"

    self compileSource: 'address
    "Returns the author address for the receiver."

    ^', aString storeString!   
saveOtherSources: aCollection
    "Private - Let the user save all the sources in aCollection."

    | file classes dicc sortBlock |
    file := (FileDialog new saveFile: (
        self
            fileName: 'No',self abreviation
            extension: 'St')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.
    CursorManager execute change.
    classes := Set new.
    aCollection do: [:each| classes add: each classField ].
    classes do: [:class|
        class fileOutOn: file.
        file nextChunkPut: String new.
    ].
    dicc := Dictionary new.
    sortBlock := [:a :b | a selector < b selector ].
    aCollection do: [:each|
        (dicc at: each classField
             ifAbsent: [dicc at: each classField
                 put: (SortedCollection sortBlock: sortBlock)]
        ) add: each
    ].
    dicc keys do: [:each|
      file
        cr; cr; nextPut: $!!;
        nextPutAll: each; space;
        nextPutAll: 'methods !!'.
        (dicc at: each) do: [:method|
            file   cr;
                    nextChunkPut: method sourceString;
                    nextPutAll: ' !!'; cr
        ]
    ].
    file close.
    CursorManager normal change.!   
dependentMethods
    "Private - Returns the Project dependent methods for individual classes."

    | result stream cls |
    result := Dictionary new.
    stream := ReadStream on: self methodsCollection.
    [stream atEnd] whileFalse: [
        cls := stream next.
        (result includesKey: cls)
        ifTrue: [ result at: cls put: (result at: cls), stream next ]
        ifFalse: [ result at: cls put: stream next asOrderedCollection ]
    ].
    ^result!
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "

    | pools |
    pools := Set new.
    self dependentClasses asArray
    do: [:each| pools addAll: each sharedPools ].
    ^pools asSortedCollection asArray select: [:pool |
        MessageBox confirm: 'Is ',pool printString,'\ a Pool Dictionary of ' withCrs,self name,' ?' ]!   
buildProjectSLL: withSource
    "Private - Build a Smalltalk Library with the receiver."

    | builder class |
    builder := self smalltalkLibraryBuilder new.

    builder
        fileName: (self fileName: 'Prj',self abreviation extension: 'SLL');
        windowFeedback;
        yourself.

	builder addClass: self.
    self mustBeInitializedWhenLoading
    ifTrue: [
        builder bindAction: (Message receiver: self selector: #initialize)
    ].
    self hasUnBindMethod
    ifTrue: [
        builder unBindAction: (Message receiver: self selector: #unBind)
    ].

	builder
        includeSource: withSource;
        writeFile.!
hasUnBindMethod
    "Private  - Must return true when the receiver needs to perform unbind actions.
    By default when #unBind method is implemented is treated as unbind code."

    ^(self class selectors includes: #unBind)! 
dependentProjects
    "Private - Returns the Project dependent proyects."

   ^(self proyectNames collect: [:each|
        Smalltalk at: each ifAbsent: [self missingProject: each] ]
    ) asArray select: [:one| one notNil ]! 
abreviation
    "Returns the abreviated name of the receiver.
     This method can be refined by subclasses for defining the store fileName of the receiver."

    ^self name!
abreviation: aString
    "Set the abreviation of the receiver"

    self compileSource: 'abreviation
    "Returns the abreviated name of the receiver."

    ^', aString storeString!   
copyright
    "Private - Returns the receiver's copyright label.
    This method can be refined by subclasses."

    ^(String with: $@),self author!  
copyright: aString
    "Set the copyright of the receiver"

    self compileSource: 'copyright
    "Returns the copyright string for the receiver."

    ^', aString storeString!   
dependentClasses
    "Private - Returns the Project dependent classes."

    | classes noSubs result |
    classes := self classNames collect: [:each|
             Smalltalk at: each ifAbsent: [self missingClass: each] ].
    result := OrderedCollection new: classes size.
    noSubs := self classesWithoutSubclasses collect: [:each|
             Smalltalk at: each ifAbsent: [self missingClass: each] ].
    classes do: [:class |
        class notNil
        ifTrue: [
            result addAll:
                ((noSubs includes: class)
                    ifTrue: [Array with: class]
                    ifFalse: [class withAllSubclasses])
        ]
    ].
    ^result!
unBindSLL
    "Try to unBind the Smalltalk Library associated with this project."

    | unBind |
	unBind := [:aName|
		(self smalltalkLibraryBuilder isBound: aName)
		ifTrue: [ self smalltalkLibraryBuilder unBind: aName ]
	].

	unBind
		value: (self fileName: self abreviation extension: 'SLL');
		value: (self fileName: 'Prj',self abreviation extension: 'SLL');
		yourself!   
classesWithoutSubclasses
    "Private - Returns the names of Project dependent classes that it's subclasses does not depends of proyect.
    This method can be refined by subclasses."

    ^Array new!  
mustBeInitializedWhenLoading
    "Private  - Must return true when the receiver needs post-loading initialization.
    By default when initialization is implemented is treated as post loading code."

    ^(self class selectors includes: #initialize)!
fileOutDictionariesInto: aStream
    "Private - Permorms fileOut of all the proyect's pool dictionaries."

    | fileOut dict |
    fileOut := [:aName|
        (dict := Smalltalk at: aName ifAbsent: [])
        isNil ifTrue: [^self error: 'PoolDictionary ',aName,'not found'].
        aStream
            cr;nextChunkPut: 'Smalltalk at: #',aName,' ifAbsent: [
    Smalltalk at: #',aName,' put: Dictionary new ].';
            cr;nextPutAll: ' ',aName.
        dict keys asSortedCollection do: [:each|
            aStream
                cr;next: 4 put: $ ;
                nextPutAll: 'at: ',each printString,
                    ' put: ',(dict at: each) printString,';'
        ].
        aStream nextChunkPut: '    yourself. '.
    ].

    self poolDictionaryNames do: [:aPool| fileOut value: aPool ]!   
hierarchy
    "Returns aString with the class hierarchy tree for the proyect.
        Ussefull as
             WBProject hierarchy edit
    "

    | remaining roots print stream margin tabSize |
    remaining := self dependentClasses asArray.
    roots := remaining "reyect childs"
        reject: [:each| remaining includes: each superclass].
    print := [:aClass|
        stream
                next: margin put: $ ; "sangria"
                nextPutAll: aClass name;cr.
        margin := margin + tabSize.
        aClass subclasses do: [:one| print value: one ].
        margin := margin  - tabSize.
    ].
    margin := 3.tabSize := 3.
    stream := WriteStream on: (String new: 1000).
    stream
        cr;space;
        nextPutAll: self class name,' hierarchy tree.';
        cr;cr.
    roots do: [:class| print value: class ].
    ^stream contents!
classNames
    "Returns the names of Project dependent classes.
    This method can be reimplemented in subclasses for adding more classes."

    ^Array new! 
profilePathName
    "Private - Must provide default path name..."

    ^Disk drivePathName,'\',(Smalltalk imageName fileNameLessPath upTo: $.),'.Ini'! 
profiler
    "Private - Returns a profiler for the receiver."

    | profiler |
    profiler := self profilerClass new
        pathName: self profilePathName;
        applicationName: self name.
    ^profiler!  
new
    "Creates an initialized object"

    ^super new initialize!
checkBound: aLibraryName
	" Private - Check library bindings if not loader yet, load the library named aLibraryName. "

    (SmalltalkLibraryBinder isBound: aLibraryName)
    ifFalse: [ SmalltalkLibraryBinder bindTo: aLibraryName ].! 
profilerClass
    "Private - Returns the current profiler class..."

    ^Smalltalk at: #WinProfiler ifAbsent: []! 
profiler
    "Returns the default profiler for the receiver"

    ^self class profiler!
checkBound: aLibraryName
	" Private - Check library bindings."

	^self class checkBound: aLibraryName! 
initialize
    "Private - Initialize the receiver"
    "Default action is to do class initialization if needed"
    "This method could be refined by subclasses..."!   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"

    ^'ARBase'!   
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."

    ^#(
       Object (
        notImplementedYet notFullyImplemented
        addedByOStyle modifiedByOStyle platformDependent
        )
    )!
initialize
    "Initializes the receiver."

	"Generate name aliases for obsolete classes."
	Smalltalk at: #OSObject put: ARObject.
! 
classesWithoutSubclasses
    "Private - Returns the names of Project dependent classes
        That it's subclasses doesn't depends from the proyect."

    ^#( ARObject ProjectClasses )!
mustBeEmbededInSLL
    "Private - Returns true if the receiver must be included within it's parts."

    ^true!
comment
	" Documentation - Returns the receiver's comment string. "

	^'ARObject classes implements basic support for Alejandro Reimondo Objects'! 
classNames
    "Private - Returns the names of Project dependent classes."

    ^#( ARObject ProjectClasses )! 
notImplementedYet
    "Generates an error because the method
     has not been implemented"
    #addedByOStyle.
    ^self error: 'Not implemented. Yet...'!