16/07/97 21:33:35
   
aditionalEventsTable
    "Private - Returns the aditional events table...
    This method can be refined by subclasses."

    #addedByOStyle.

        "WM_...   wmSelector           eventName (or #none)"
    ^#(
         (16r0000  none needsPalette) "WM_ = 0 do no wmMessage registration but st-event registration"
        (16r030F  wmQueryNewPalette:with: queryNewPalette)
        (16r0310  wmPaletteIsChanging:with: paletteIsChanging)
        (16r0311  wmPaletteChanged:with: paletteChanged)
    )!  
fileIn: pathName
    "FilesIn the file with pathName."

	| file |
	#addedByOStyle.
	pathName isStream ifTrue: [ ^pathName fileIn ].
	file := self fromPath: pathName.
    file exists ifFalse: [ ^self ].
    file := file readStream.
	[ file fileIn ] ensure: [ file close ]!  
run: commandLine
    "Executes the command line commandLine"

    ^self new run: commandLine!  
release
        "Delete the receiver from the system thus freeing
         the system resources associated with the receiver.

    Touched by Ale for non-deletion if invalid handle..."
    #modifiedByOStyle.
    self handle isNil ifTrue: [ ^self ].

    ( GDILibrary deleteMetaFile: self handle )
        ifFalse: [ self osWarning ].
    hMetaFile := nil! 
createPolygonalRegion: anArrayOfPoints
    "Create a polygonal region from points and answer its handle.
    Implemented by Ale."
    | hRgn winPointList nPoints |
    #addedByOStyle.
    winPointList := self winPointList: anArrayOfPoints.
    nPoints := anArrayOfPoints size.
    ( hRgn := GDILibrary
        createPolygonRgn: winPointList asParameter
         cPoints: nPoints
         mode: Winding) = 0
            ifTrue: [ ^self osError ].
    ^hRgn!  
angle
    "Answers the angle in degrees of the font"
    #addedByOStyle.

    ^self logicalFont lfEscapement / 10!
angle: anInteger
    "Sets the angle in degrees of the font"
    #addedByOStyle.

    self logicalFont lfEscapement: anInteger * 10.! 
initializeSoundConstants
    "Private - Initialize PlaySound constants...
        MMSystemDLL initializeSoundConstants
    "

    MultiMediaConstants
        "Win3.1 constants..."
        at: 'SndSync' put: 0; "play synchronously (default)"
        at: 'SndAsync' put: 1; "play asynchronously"
        at: 'SndNodefault' put: 2; "silence not default, if sound not found"
        at: 'SndMemory' put: 4; "lpszSoundName points to a memory file"
        at: 'SndLoop' put: 8; "loop the sound until next sndPlaySound"
        at: 'SndNostop' put: 16; "don't stop any currently playing sound"
        "Win32 extensions..."
        at: 'SndAlias' put: 16r10000; "name is a WIN.INI [sounds] entry"
        at: 'SndFilename' put: 16r20000; "name is a file name"
        at: 'SndResource' put: 16r40004; "name is a resource name or atom"
        at: 'SndAliasid' put: 16r110000; "name is a WIN.INI [sounds] entry identifier"
        yourself!   
fileName
        "Answer the receiver's file name."

    ^'WinMM.dll' "mmSystem.dll de 32 bits..."!
initializeStructures
    "Private - Initializes the structures for the interfase.
    MMSystemDLL initializeStructures
    "

    self
        registerType: 'WaveOutCaps'
        as:#(
            (wMid word)                        "manufacturer ID"
            (wPid word)                        "product ID"
            (vDriverVersion uint)        "driver version"
            (szPname 32 asCstring)        "product name (asciiZ)"
            (dwFormats dword)            "formats supported"
            (wChannels word)                "number of source channels supported"
            (dwSupport dword)            "functionality supported by the driver"
        );
        yourself.

    true ifTrue: [ ^self ]. "not ported yet..."
    self
        type: 'MMTime'
        is: #(
            (wType word)
            (ms dword)
            (sample dword)
            (cb dword)
                (hour byte) (min byte) (sec byte) "SMPTE"
                (frame byte) (fps byte) (dummy byte)
            (songptrpos dword) "midi"
        );
        type: 'DrvConfigInfo'
        is: #(
            (dwDCISize dword)
            (lpszDCISectionName long asWinAddress)
            (lpszDCIAliasName long asWinAddress)
        );
        type: 'WaveHdr'
        is: #(
            (lpData long asWinAddress)    "pointer to locked data buffer"
            (dwBufferLength dword)           "length of data buffer"
            (dwBytesRecorded dword)       "used for input only"
            (dwUser dword)                        "for client's use"
            (dwFlags dword)                       "assorted flags"
            (dwLoops dword)                      "loop control counter"
            (lpNext long asWinAddress)    "reserved for driver"
            (reserved dword)                      "reserved for driver"
        );
        type: 'WaveInCaps'
        is: #(
            (wMid word)
            (wPid word)
            (vDriverVersion word)
            (szPname 32 asString)
            (dwFormats dword)
            (wChannels word)
        );
        type: 'WaveFormat'
        is: #(
            (wFormatTag word)              "format type"
            (nChannels word)                "number of channels (mono, stereo, etc.)"
            (nSamplesPerSec dword)    "sample rate"
            (nAvgBytesPerSec dword)  "for buffer estimation"
            (nBlockAlign word)               "block size of data"
        );
        type: 'PCMWaveFormat'
        is: #(
            (wFormatTag word)              "format type"
            (nChannels word)                "number of channels (mono, stereo, etc.)"
            (nSamplesPerSec dword)    "sample rate"
            (nAvgBytesPerSec dword)  "for buffer estimation"
            (nBlockAlign word)               "block size of data"
            (wBitsPerSample word)
        );
        type: 'MidiOutCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
            (wTechnology word)        "type of device"
            (wVoices word)                "# of voices"
            (wNotes word)                 "max # notes"
            (wChannelMask word)     "channels used"
            (dwSupport dword)          "functionality supported by the driver"
        );
        type: 'MidiInCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
        );
        type: 'MidiHdr'
        is: #(
            (lpData long asWinAddress)  "pointer to locked data block"
            (dwBufferLength dword)         "length of data in data block"
            (dwBytesRecorded dword)     "used for input only"
            (dwUser dword)                      "for client's use"
            (dwFlags dword)                     "assorted flags"
            (lpNext long asWinAddress)  "reserved for driver"
            (reserved dword)                    "reserved for driver"
        );
        type: 'AuxCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
            (wTechnology word)        "type of device"
            (dwSupport dword)          "functionality supported by the driver"
        );
        type: 'TimeCaps'
        is: #(
            (wPeriodMin word)          "Minimum period supported"
            (wPeriodMax word)         "Maximum period supported"
        );
        type: 'JoyCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (szPname 32 asString)   "product name"
            (wXmin word) (wXmax word)
            (wYmin word) (wYmax word)
            (wZmin word) (wZmax word)
            (wNumButtons word)
            (wPeriodMin word) (wPeriodMax word)
        );
        type: 'JoyInfo'
        is: #(
            (wXpos word) (wYpos word) (wZpos word)
            (wButtons word)  "buttons states"
        );
        yourself!   
initialize
    "Initializes the receiver
    MMSystemDLL initialize
    "

    super initialize.

    self
        initializeMMConstants;
        initializeStructures!  
initializeMMConstants
    "Initializes the PoolDictionary
    MMSystemDLL initializeMMConstants
    "

    MultiMediaConstants := Dictionary new.

    self
        initializeSoundConstants;
        initializeWaveConstants;
        yourself.

    " Non ported Yet...
      Escribir metodos individuales de inicializacion
         por cada topico agregado... (como #initializeSoundConstants)

      at: 'AuxcapsAuxin' put: 2;
      at: 'AuxcapsCdaudio' put: 1;
      at: 'AuxcapsLrvolume' put: 2;
      at: 'AuxcapsVolume' put: 1;
      at: 'C1Transparent' put: 1;
      at: 'CallbackFunction' put: 196608;
      at: 'CallbackNull' put: 0;
      at: 'CallbackTask' put: 131072;
      at: 'CallbackTypemask' put: 458752;
      at: 'CallbackWindow' put: 65536;
      at: 'Caps1' put: 94;
      at: 'Cfsepchar' put: '+';
      at: 'DrvCancel' put: 0;
      at: 'DrvClose' put: 4;
      at: 'DrvConfigure' put: 7;
      at: 'DrvDisable' put: 5;
      at: 'DrvEnable' put: 2;
      at: 'DrvFree' put: 6;
      at: 'DrvInstall' put: 9;
      at: 'DrvLoad' put: 1;
      at: 'DrvMciFirst' put: 2048;
      at: 'DrvMciLast' put: 6143;
      at: 'DrvOk' put: 1;
      at: 'DrvOpen' put: 3;
      at: 'DrvQueryconfigure' put: 8;
      at: 'DrvRemove' put: 10;
      at: 'DrvReserved' put: 2048;
      at: 'DrvRestart' put: 2;
      at: 'DrvUser' put: 16384;
      at: 'JoyButton1' put: 1;
      at: 'JoyButton1chg' put: 256;
      at: 'JoyButton2' put: 2;
      at: 'JoyButton2chg' put: 512;
      at: 'JoyButton3' put: 4;
      at: 'JoyButton3chg' put: 1024;
      at: 'JoyButton4' put: 8;
      at: 'JoyButton4chg' put: 2048;
      at: 'JoyerrBase' put: 160;
      at: 'JoyerrNocando' put: 166;
      at: 'JoyerrNoerror' put: 0;
      at: 'JoyerrParms' put: 165;
      at: 'JoyerrUnplugged' put: 167;
      at: 'Joystickid1' put: 0;
      at: 'Joystickid2' put: 1;
      at: 'Maxerrorlength' put: 128;
      at: 'Maxpnamelen' put: 32;
      at: 'MciAllDeviceId' put: 65535;
      at: 'MciAnimGetdevcapsCanReverse' put: 16385;
      at: 'MciAnimGetdevcapsCanStretch' put: 16391;
      at: 'MciAnimGetdevcapsFastRate' put: 16386;
      at: 'MciAnimGetdevcapsMaxWindows' put: 16392;
      at: 'MciAnimGetdevcapsNormalRate' put: 16388;
      at: 'MciAnimGetdevcapsPalettes' put: 16390;
      at: 'MciAnimGetdevcapsSlowRate' put: 16387;
      at: 'MciAnimInfoText' put: 65536;
      at: 'MciAnimOpenNostatic' put: 262144;
      at: 'MciAnimOpenParent' put: 131072;
      at: 'MciAnimOpenWs' put: 65536;
      at: 'MciAnimPlayFast' put: 262144;
      at: 'MciAnimPlayReverse' put: 131072;
      at: 'MciAnimPlayScan' put: 1048576;
      at: 'MciAnimPlaySlow' put: 524288;
      at: 'MciAnimPlaySpeed' put: 65536;
      at: 'MciAnimPutDestination' put: 262144;
      at: 'MciAnimPutSource' put: 131072;
      at: 'MciAnimRealizeBkgd' put: 131072;
      at: 'MciAnimRealizeNorm' put: 65536;
      at: 'MciAnimRect' put: 65536;
      at: 'MciAnimStatusForward' put: 16386;
      at: 'MciAnimStatusHpal' put: 16388;
      at: 'MciAnimStatusHwnd' put: 16387;
      at: 'MciAnimStatusSpeed' put: 16385;
      at: 'MciAnimStatusStretch' put: 16389;
      at: 'MciAnimStepFrames' put: 131072;
      at: 'MciAnimStepReverse' put: 65536;
      at: 'MciAnimUpdateHdc' put: 131072;
      at: 'MciAnimWhereDestination' put: 262144;
      at: 'MciAnimWhereSource' put: 131072;
      at: 'MciAnimWindowDefault' put: 0;
      at: 'MciAnimWindowDisableStretch' put: 2097152;
      at: 'MciAnimWindowEnableStretch' put: 1048576;
      at: 'MciAnimWindowHwnd' put: 65536;
      at: 'MciAnimWindowState' put: 262144;
      at: 'MciAnimWindowText' put: 524288;
      at: 'MciBreak' put: 2065;
      at: 'MciBreakHwnd' put: 512;
      at: 'MciBreakKey' put: 256;
      at: 'MciBreakOff' put: 1024;
      at: 'MciCdOffset' put: 1088;
      at: 'MciClose' put: 2052;
      at: 'MciCopy' put: 2130;
      at: 'MciCue' put: 2096;
      at: 'MciCut' put: 2129;
      at: 'MciDelete' put: 2134;
      at: 'MciDevtypeAnimation' put: 519;
      at: 'MciDevtypeCdAudio' put: 516;
      at: 'MciDevtypeDat' put: 517;
      at: 'MciDevtypeDigitalVideo' put: 520;
      at: 'MciDevtypeFirst' put: 513;
      at: 'MciDevtypeLast' put: 523;
      at: 'MciDevtypeOther' put: 521;
      at: 'MciDevtypeOverlay' put: 515;
      at: 'MciDevtypeScanner' put: 518;
      at: 'MciDevtypeSequencer' put: 523;
      at: 'MciDevtypeVcr' put: 513;
      at: 'MciDevtypeVideodisc' put: 514;
      at: 'MciDevtypeWaveformAudio' put: 522;
      at: 'McierrBadConstant' put: 290;
      at: 'McierrBadInteger' put: 270;
      at: 'McierrBadTimeFormat' put: 293;
      at: 'McierrBase' put: 256;
      at: 'McierrCannotLoadDriver' put: 266;
      at: 'McierrCannotUseAll' put: 279;
      at: 'McierrCreatewindow' put: 347;
      at: 'McierrCustomDriverBase' put: 512;
      at: 'McierrDeviceLocked' put: 288;
      at: 'McierrDeviceNotReady' put: 276;
      at: 'McierrDeviceOpen' put: 265;
      at: 'McierrDeviceTypeRequired' put: 287;
      at: 'McierrDriver' put: 278;
      at: 'McierrDriverInternal' put: 272;
      at: 'McierrDuplicateAlias' put: 289;
      at: 'McierrDuplicateFlags' put: 295;
      at: 'McierrExtensionNotFound' put: 281;
      at: 'McierrExtraCharacters' put: 305;
      at: 'McierrFilenameRequired' put: 304;
      at: 'McierrFileNotFound' put: 275;
      at: 'McierrFileNotSaved' put: 286;
      at: 'McierrFileRead' put: 348;
      at: 'McierrFileWrite' put: 349;
      at: 'McierrFlagsNotCompatible' put: 284;
      at: 'McierrHardware' put: 262;
      at: 'McierrIllegalForAutoOpen' put: 303;
      at: 'McierrInternal' put: 277;
      at: 'McierrInvalidDeviceId' put: 257;
      at: 'McierrInvalidDeviceName' put: 263;
      at: 'McierrInvalidFile' put: 296;
      at: 'McierrMissingCommandString' put: 267;
      at: 'McierrMissingDeviceName' put: 292;
      at: 'McierrMissingParameter' put: 273;
      at: 'McierrMissingStringArgument' put: 269;
      at: 'McierrMultiple' put: 280;
      at: 'McierrMustUseShareable' put: 291;
      at: 'McierrNewRequiresAlias' put: 299;
      at: 'McierrNoClosingQuote' put: 294;
      at: 'McierrNoElementAllowed' put: 301;
      at: 'McierrNonapplicableFunction' put: 302;
      at: 'McierrNotifyOnAutoOpen' put: 300;
      at: 'McierrNoWindow' put: 346;
      at: 'McierrNullParameterBlock' put: 297;
      at: 'McierrOutOfMemory' put: 264;
      at: 'McierrOutofrange' put: 282;
      at: 'McierrParamOverflow' put: 268;
      at: 'McierrParserInternal' put: 271;
      at: 'McierrSeqDivIncompatible' put: 336;
      at: 'McierrSeqPortInuse' put: 337;
      at: 'McierrSeqPortMapnodevice' put: 339;
      at: 'McierrSeqPortMiscerror' put: 340;
      at: 'McierrSeqPortNonexistent' put: 338;
      at: 'McierrSeqPortunspecified' put: 342;
      at: 'McierrSeqTimer' put: 341;
      at: 'McierrUnnamedResource' put: 298;
      at: 'McierrUnrecognizedCommand' put: 261;
      at: 'McierrUnrecognizedKeyword' put: 259;
      at: 'McierrUnsupportedFunction' put: 274;
      at: 'McierrWaveInputsinuse' put: 322;
      at: 'McierrWaveInputsunsuitable' put: 328;
      at: 'McierrWaveInputunspecified' put: 325;
      at: 'McierrWaveOutputsinuse' put: 320;
      at: 'McierrWaveOutputsunsuitable' put: 326;
      at: 'McierrWaveOutputunspecified' put: 324;
      at: 'McierrWaveSetinputinuse' put: 323;
      at: 'McierrWaveSetinputunsuitable' put: 329;
      at: 'McierrWaveSetoutputinuse' put: 321;
      at: 'McierrWaveSetoutputunsuitable' put: 327;
      at: 'MciEscape' put: 2053;
      at: 'MciFormatBytes' put: 8;
      at: 'MciFormatFrames' put: 3;
      at: 'MciFormatHms' put: 1;
      at: 'MciFormatMilliseconds' put: 0;
      at: 'MciFormatMsf' put: 2;
      at: 'MciFormatSamples' put: 9;
      at: 'MciFormatSmpte24' put: 4;
      at: 'MciFormatSmpte25' put: 5;
      at: 'MciFormatSmpte30' put: 6;
      at: 'MciFormatSmpte30drop' put: 7;
      at: 'MciFormatTmsf' put: 10;
      at: 'MciFreeze' put: 2116;
      at: 'MciFrom' put: 4;
      at: 'MciGetdevcaps' put: 2059;
      at: 'MciGetdevcapsCanEject' put: 7;
      at: 'MciGetdevcapsCanPlay' put: 8;
      at: 'MciGetdevcapsCanRecord' put: 1;
      at: 'MciGetdevcapsCanSave' put: 9;
      at: 'MciGetdevcapsCompoundDevice' put: 6;
      at: 'MciGetdevcapsDeviceType' put: 4;
      at: 'MciGetdevcapsHasAudio' put: 2;
      at: 'MciGetdevcapsHasVideo' put: 3;
      at: 'MciGetdevcapsItem' put: 256;
      at: 'MciGetdevcapsUsesFiles' put: 5;
      at: 'MciInfo' put: 2058;
      at: 'MciInfoFile' put: 512;
      at: 'MciInfoProduct' put: 256;
      at: 'MciLoad' put: 2128;
      at: 'MciLoadFile' put: 256;
      at: 'MciModeNotReady' put: 524;
      at: 'MciModeOpen' put: 530;
      at: 'MciModePause' put: 529;
      at: 'MciModePlay' put: 526;
      at: 'MciModeRecord' put: 527;
      at: 'MciModeSeek' put: 528;
      at: 'MciModeStop' put: 525;
      at: 'MciNotify' put: 1;
      at: 'MciNotifyAborted' put: 4;
      at: 'MciNotifyFailure' put: 8;
      at: 'MciNotifySuccessful' put: 1;
      at: 'MciNotifySuperseded' put: 2;
      at: 'MciOpen' put: 2051;
      at: 'MciOpenAlias' put: 1024;
      at: 'MciOpenElement' put: 512;
      at: 'MciOpenElementId' put: 2048;
      at: 'MciOpenShareable' put: 256;
      at: 'MciOpenType' put: 8192;
      at: 'MciOpenTypeId' put: 4096;
      at: 'MciOvlyGetdevcapsCanFreeze' put: 16386;
      at: 'MciOvlyGetdevcapsCanStretch' put: 16385;
      at: 'MciOvlyGetdevcapsMaxWindows' put: 16387;
      at: 'MciOvlyInfoText' put: 65536;
      at: 'MciOvlyOpenParent' put: 131072;
      at: 'MciOvlyOpenWs' put: 65536;
      at: 'MciOvlyPutDestination' put: 262144;
      at: 'MciOvlyPutFrame' put: 524288;
      at: 'MciOvlyPutSource' put: 131072;
      at: 'MciOvlyPutVideo' put: 1048576;
      at: 'MciOvlyRect' put: 65536;
      at: 'MciOvlyStatusHwnd' put: 16385;
      at: 'MciOvlyStatusStretch' put: 16386;
      at: 'MciOvlyWhereDestination' put: 262144;
      at: 'MciOvlyWhereFrame' put: 524288;
      at: 'MciOvlyWhereSource' put: 131072;
      at: 'MciOvlyWhereVideo' put: 1048576;
      at: 'MciOvlyWindowDefault' put: 0;
      at: 'MciOvlyWindowDisableStretch' put: 2097152;
      at: 'MciOvlyWindowEnableStretch' put: 1048576;
      at: 'MciOvlyWindowHwnd' put: 65536;
      at: 'MciOvlyWindowState' put: 262144;
      at: 'MciOvlyWindowText' put: 524288;
      at: 'MciPaste' put: 2131;
      at: 'MciPause' put: 2057;
      at: 'MciPlay' put: 2054;
      at: 'MciPut' put: 2114;
      at: 'MciRealize' put: 2112;
      at: 'MciRecord' put: 2063;
      at: 'MciRecordInsert' put: 256;
      at: 'MciRecordOverwrite' put: 512;
      at: 'MciResume' put: 2133;
      at: 'MciSave' put: 2067;
      at: 'MciSaveFile' put: 256;
      at: 'MciSeek' put: 2055;
      at: 'MciSeekToEnd' put: 512;
      at: 'MciSeekToStart' put: 256;
      at: 'MciSeqDivPpqn' put: 1216;
      at: 'MciSeqDivSmpte24' put: 1217;
      at: 'MciSeqDivSmpte25' put: 1218;
      at: 'MciSeqDivSmpte30' put: 1220;
      at: 'MciSeqDivSmpte30drop' put: 1219;
      at: 'MciSeqFile' put: 16386;
      at: 'MciSeqFormatSongptr' put: 16385;
      at: 'MciSeqMidi' put: 16387;
      at: 'MciSeqNone' put: 65533;
      at: 'MciSeqOffset' put: 1216;
      at: 'MciSeqSetMaster' put: 524288;
      at: 'MciSeqSetOffset' put: 16777216;
      at: 'MciSeqSetPort' put: 131072;
      at: 'MciSeqSetSlave' put: 262144;
      at: 'MciSeqSetTempo' put: 65536;
      at: 'MciSeqSmpte' put: 16388;
      at: 'MciSeqStatusDivtype' put: 16394;
      at: 'MciSeqStatusMaster' put: 16392;
      at: 'MciSeqStatusOffset' put: 16393;
      at: 'MciSeqStatusPort' put: 16387;
      at: 'MciSeqStatusSlave' put: 16391;
      at: 'MciSeqStatusTempo' put: 16386;
      at: 'MciSet' put: 2061;
      at: 'MciSetAudio' put: 2048;
      at: 'MciSetAudioAll' put: 0;
      at: 'MciSetAudioLeft' put: 1;
      at: 'MciSetAudioRight' put: 2;
      at: 'MciSetDoorClosed' put: 512;
      at: 'MciSetDoorOpen' put: 256;
      at: 'MciSetOff' put: 16384;
      at: 'MciSetOn' put: 8192;
      at: 'MciSetTimeFormat' put: 1024;
      at: 'MciSetVideo' put: 4096;
      at: 'MciSound' put: 2066;
      at: 'MciSoundName' put: 256;
      at: 'MciSpin' put: 2060;
      at: 'MciStatus' put: 2068;
      at: 'MciStatusCurrentTrack' put: 8;
      at: 'MciStatusItem' put: 256;
      at: 'MciStatusLength' put: 1;
      at: 'MciStatusMediaPresent' put: 5;
      at: 'MciStatusMode' put: 4;
      at: 'MciStatusNumberOfTracks' put: 3;
      at: 'MciStatusPosition' put: 2;
      at: 'MciStatusReady' put: 7;
      at: 'MciStatusStart' put: 512;
      at: 'MciStatusTimeFormat' put: 6;
      at: 'MciStep' put: 2062;
      at: 'MciStop' put: 2056;
      at: 'MciStringOffset' put: 512;
      at: 'MciSysinfo' put: 2064;
      at: 'MciSysinfoInstallname' put: 2048;
      at: 'MciSysinfoName' put: 1024;
      at: 'MciSysinfoOpen' put: 512;
      at: 'MciSysinfoQuantity' put: 256;
      at: 'MciTo' put: 8;
      at: 'MciTrack' put: 16;
      at: 'MciUnfreeze' put: 2117;
      at: 'MciUpdate' put: 2132;
      at: 'MciUserMessages' put: 3072;
      at: 'MciVdEscapeString' put: 256;
      at: 'MciVdFormatTrack' put: 16385;
      at: 'MciVdGetdevcapsCanReverse' put: 16386;
      at: 'MciVdGetdevcapsCav' put: 131072;
      at: 'MciVdGetdevcapsClv' put: 65536;
      at: 'MciVdGetdevcapsFastRate' put: 16387;
      at: 'MciVdGetdevcapsNormalRate' put: 16389;
      at: 'MciVdGetdevcapsSlowRate' put: 16388;
      at: 'MciVdMediaCav' put: 1027;
      at: 'MciVdMediaClv' put: 1026;
      at: 'MciVdMediaOther' put: 1028;
      at: 'MciVdModePark' put: 1025;
      at: 'MciVdOffset' put: 1024;
      at: 'MciVdPlayFast' put: 131072;
      at: 'MciVdPlayReverse' put: 65536;
      at: 'MciVdPlayScan' put: 524288;
      at: 'MciVdPlaySlow' put: 1048576;
      at: 'MciVdPlaySpeed' put: 262144;
      at: 'MciVdSeekReverse' put: 65536;
      at: 'MciVdSpinDown' put: 131072;
      at: 'MciVdSpinUp' put: 65536;
      at: 'MciVdStatusDiscSize' put: 16390;
      at: 'MciVdStatusForward' put: 16387;
      at: 'MciVdStatusMediaType' put: 16388;
      at: 'MciVdStatusSide' put: 16389;
      at: 'MciVdStatusSpeed' put: 16386;
      at: 'MciVdStepFrames' put: 65536;
      at: 'MciVdStepReverse' put: 131072;
      at: 'MciWait' put: 2;
      at: 'MciWaveGetdevcapsInputs' put: 16385;
      at: 'MciWaveGetdevcapsOutputs' put: 16386;
      at: 'MciWaveInput' put: 4194304;
      at: 'MciWaveOffset' put: 1152;
      at: 'MciWaveOpenBuffer' put: 65536;
      at: 'MciWaveOutput' put: 8388608;
      at: 'MciWaveSetAnyinput' put: 67108864;
      at: 'MciWaveSetAnyoutput' put: 134217728;
      at: 'MciWaveSetAvgbytespersec' put: 524288;
      at: 'MciWaveSetBitspersample' put: 2097152;
      at: 'MciWaveSetBlockalign' put: 1048576;
      at: 'MciWaveSetChannels' put: 131072;
      at: 'MciWaveSetFormattag' put: 65536;
      at: 'MciWaveSetSamplespersec' put: 262144;
      at: 'MciWaveStatusAvgbytespersec' put: 16388;
      at: 'MciWaveStatusBitspersample' put: 16390;
      at: 'MciWaveStatusBlockalign' put: 16389;
      at: 'MciWaveStatusChannels' put: 16386;
      at: 'MciWaveStatusFormattag' put: 16385;
      at: 'MciWaveStatusLevel' put: 16391;
      at: 'MciWaveStatusSamplespersec' put: 16387;
      at: 'MciWhere' put: 2115;
      at: 'MciWindow' put: 2113;
      at: 'MhdrDone' put: 1;
      at: 'MhdrInqueue' put: 4;
      at: 'MhdrPrepared' put: 2;
      at: 'MidicapsLrvolume' put: 2;
      at: 'MidicapsVolume' put: 1;
      at: 'MidierrBase' put: 64;
      at: 'MidierrLasterror' put: 68;
      at: 'MidierrNodevice' put: 68;
      at: 'MidierrNomap' put: 66;
      at: 'MidierrNotready' put: 67;
      at: 'MidierrStillplaying' put: 65;
      at: 'MidierrUnprepared' put: 64;
      at: 'Midimapper' put: -1;
      at: 'MimClose' put: 962;
      at: 'MimData' put: 963;
      at: 'MimError' put: 965;
      at: 'MimLongdata' put: 964;
      at: 'MimLongerror' put: 966;
      at: 'MimOpen' put: 961;
      at: 'MmAdlib' put: 9;
      at: 'MmioAllocbuf' put: 65536;
      at: 'MmioCompat' put: 0;
      at: 'MmioCreate' put: 4096;
      at: 'MmioCreatelist' put: 64;
      at: 'MmioCreateriff' put: 32;
      at: 'MmioDefaultbuffer' put: 8192;
      at: 'MmioDelete' put: 512;
      at: 'MmioDenynone' put: 64;
      at: 'MmioDenyread' put: 48;
      at: 'MmioDenywrite' put: 32;
      at: 'MmioDirty' put: 268435456;
      at: 'MmioEmptybuf' put: 16;
      at: 'MmioerrBase' put: 256;
      at: 'MmioerrCannotclose' put: 260;
      at: 'MmioerrCannotexpand' put: 264;
      at: 'MmioerrCannotopen' put: 259;
      at: 'MmioerrCannotread' put: 261;
      at: 'MmioerrCannotseek' put: 263;
      at: 'MmioerrCannotwrite' put: 262;
      at: 'MmioerrChunknotfound' put: 265;
      at: 'MmioerrFilenotfound' put: 257;
      at: 'MmioerrOutofmemory' put: 258;
      at: 'MmioerrUnbuffered' put: 266;
      at: 'MmioExclusive' put: 16;
      at: 'MmioFhopen' put: 16;
      at: 'MmioFindchunk' put: 16;
      at: 'MmioFindlist' put: 64;
      at: 'MmioFindproc' put: 262144;
      at: 'MmioFindriff' put: 32;
      at: 'MmioInstallproc' put: 65536;
      at: 'MmiomClose' put: 4;
      at: 'MmiomOpen' put: 3;
      at: 'MmiomRead' put: 0;
      at: 'MmiomSeek' put: 2;
      at: 'MmiomUser' put: 32768;
      at: 'MmiomWrite' put: 1;
      at: 'MmiomWriteflush' put: 5;
      at: 'MmioRead' put: 0;
      at: 'MmioReadwrite' put: 2;
      at: 'MmioRemoveproc' put: 131072;
      at: 'MmioRwmode' put: 3;
      at: 'MmioSharemode' put: 112;
      at: 'MmioToupper' put: 16;
      at: 'MmioWrite' put: 1;
      at: 'MmJoy1buttondown' put: 949;
      at: 'MmJoy1buttonup' put: 951;
      at: 'MmJoy1move' put: 928;
      at: 'MmJoy1zmove' put: 930;
      at: 'MmJoy2buttondown' put: 950;
      at: 'MmJoy2buttonup' put: 952;
      at: 'MmJoy2move' put: 929;
      at: 'MmJoy2zmove' put: 931;
      at: 'MmMcinotify' put: 953;
      at: 'MmMcisystemString' put: 970;
      at: 'MmMicrosoft' put: 1;
      at: 'MmMidiMapper' put: 1;
      at: 'MmMimClose' put: 962;
      at: 'MmMimData' put: 963;
      at: 'MmMimError' put: 965;
      at: 'MmMimLongdata' put: 964;
      at: 'MmMimLongerror' put: 966;
      at: 'MmMimOpen' put: 961;
      at: 'MmMomClose' put: 968;
      at: 'MmMomDone' put: 969;
      at: 'MmMomOpen' put: 967;
      at: 'MmMpu401Midiin' put: 11;
      at: 'MmMpu401Midiout' put: 10;
      at: 'MmPcJoystick' put: 12;
      at: 'MmSndblstMidiin' put: 4;
      at: 'MmSndblstMidiout' put: 3;
      at: 'MmSndblstSynth' put: 5;
      at: 'MmSndblstWavein' put: 7;
      at: 'MmSndblstWaveout' put: 6;
      at: 'MmsyserrAllocated' put: 4;
      at: 'MmsyserrBaddeviceid' put: 2;
      at: 'MmsyserrBaderrnum' put: 9;
      at: 'MmsyserrBase' put: 0;
      at: 'MmsyserrError' put: 1;
      at: 'MmsyserrInvalhandle' put: 5;
      at: 'MmsyserrLasterror' put: 9;
      at: 'MmsyserrNodriver' put: 6;
      at: 'MmsyserrNoerror' put: 0;
      at: 'MmsyserrNomem' put: 7;
      at: 'MmsyserrNotenabled' put: 3;
      at: 'MmsyserrNotsupported' put: 8;
      at: 'Mmsystem' put: 1;
      at: 'MmWaveMapper' put: 2;
      at: 'MmWimClose' put: 959;
      at: 'MmWimData' put: 960;
      at: 'MmWimOpen' put: 958;
      at: 'MmWomClose' put: 956;
      at: 'MmWomDone' put: 957;
      at: 'MmWomOpen' put: 955;
      at: 'ModFmsynth' put: 4;
      at: 'ModMapper' put: 5;
      at: 'ModMidiport' put: 1;
      at: 'ModSqsynth' put: 3;
      at: 'ModSynth' put: 2;
      at: 'MomClose' put: 968;
      at: 'MomDone' put: 969;
      at: 'MomOpen' put: 967;
      at: 'Newtransparent' put: 3;
      at: 'Queryropsupport' put: 40;
      at: 'ScScreensave' put: 61760;
      at: 'SeekCur' put: 1;
      at: 'SeekEnd' put: 2;
      at: 'SeekSet' put: 0;
      at: 'Selectdib' put: 41;
      at: 'TimeBytes' put: 4;
      at: 'TimeMidi' put: 16;
      at: 'TimeMs' put: 1;
      at: 'TimeOneshot' put: 0;
      at: 'TimePeriodic' put: 1;
      at: 'TimerrBase' put: 96;
      at: 'TimerrNocando' put: 97;
      at: 'TimerrNoerror' put: 0;
      at: 'TimerrStruct' put: 129;
      at: 'TimeSamples' put: 2;
      at: 'TimeSmpte' put: 8;
      at: 'WaveFormat1m08' put: 1;
      at: 'WaveFormat1m16' put: 4;
      at: 'WaveFormat1s08' put: 2;
      at: 'WaveFormat1s16' put: 8;
      at: 'WaveFormat2m08' put: 16;
      at: 'WaveFormat2m16' put: 64;
      at: 'WaveFormat2s08' put: 32;
      at: 'WaveFormat2s16' put: 128;
      at: 'WaveFormat4m08' put: 256;
      at: 'WaveFormat4m16' put: 1024;
      at: 'WaveFormat4s08' put: 512;
      at: 'WaveFormat4s16' put: 2048;
      at: 'WaveFormatPcm' put: 1;
      at: 'WaveFormatQuery' put: 1;
      at: 'WaveInvalidformat' put: 0;
      at: 'WaveMapper' put: -1;
      at: 'WaverrBadformat' put: 32;
      at: 'WaverrBase' put: 32;
      at: 'WaverrLasterror' put: 34;
      at: 'WaverrStillplaying' put: 33;
      at: 'WaverrUnprepared' put: 34;
      at: 'WhdrBeginloop' put: 4;
      at: 'WhdrDone' put: 1;
      at: 'WhdrEndloop' put: 8;
      at: 'WhdrInqueue' put: 16;
      at: 'WhdrPrepared' put: 2;
      at: 'WimClose' put: 959;
      at: 'WimData' put: 960;
      at: 'WimOpen' put: 958;
      at: 'WomClose' put: 956;
      at: 'WomDone' put: 957;
      at: 'WomOpen' put: 955;
        yourself.

    "!   
initializeWaveConstants
    "Private - Initialize Wave constants...
        MMSystemDLL initializeWaveConstants
    "

    MultiMediaConstants
        "Win3.1 constants..."
        at: 'WavecapsLrvolume' put: 8;    "Supports separate left and right volume control."
        at: 'WavecapsPitch' put: 1;    "Supports pitch control."
        at: 'WavecapsPlaybackrate' put: 2;    "Supports playback rate control."
        at: 'WavecapsVolume' put: 4;    "Supports volume control."
        at: 'WavecapsSync' put: 16r10;    "Specifies that the driver is synchronous and will block while playing a buffer."
        "Win32 extensions..."
        yourself!
version
    "Returns currently supported version"
    ^self class version!  
sndPlaySound: soundName flags: flags
    <api: sndPlaySoundA struct long boolean>
    ^self invalidArgument
"
    ^self playSound: soundName module: nil flags: flags
"! 
mciSendString: aString returnString: result size: size callback: handle
    <api: mciSendStringA struct struct ushort handle long>
    ^self invalidArgument!   
waveOutGetDevCaps: idDevice lpwoc: lpwoc cbwoc: cbwoc
    <api: waveOutGetDevCapsA ushort struct ushort ushort>
    ^self invalidArgument!  
playSound: soundName module: hModule flags: flags
    <api: PlaySound struct handle long boolean>
    ^self invalidArgument!
mciGetError: value returnString: result size: size
    <api: mciGetErrorStringA long struct ushort boolean>
    ^self invalidArgument!  
free
    "Private - Free the DLL."
    super free.
    self fillFromAddress: NullHandle!   
waveOutGetNumDevs
    <api: waveOutGetNumDevs ushort>
    ^self invalidArgument!
fromStream: aStream
    "Create a DIB bitmap from aStream; Returns nil if failed...
    Implemented by Ale..."

    | dib type |
    #addedByOStyle.

    type := String new: 2.
    type at: 1 put: aStream next.
    type at: 2 put: aStream next.
    "check file type and position file pointer to DIB's info header."
    type  = 'BM'
        ifTrue: [aStream skip: 12]
        ifFalse: [
            type = 'BA'
                ifTrue: [aStream skip: 26]
                ifFalse: [^nil]
            ].

    dib := self new
        fromStream: aStream.
    ^dib!  
getBytesFor: aByteObject
   "Directly copy from the stream to aByteObject.
    Implemented by Ale..."

    #addedByOStyle.
    ^self
         copyFrom: self position
         to: self position + aByteObject size - 1
         into: aByteObject!   
fromStream: aStream
        "Private - Set the receiver's instance variables,
         parsing aStream. aStream must point to the DIB's
         info header.
    Touched by Ale for stream advance & more conservative implementation."
    | bytes |
    bitmapInfo := Bitmap readBitmapInfo: aStream.
    bitmapInfo sizeImage = 0
        ifTrue: [bytes := (((
            bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height]
        ifFalse: [bytes := bitmapInfo sizeImage].

    bits := ByteArray new: bytes.
    #modifiedByOStyle.
    "  Ale - No abanzaba el stream y ademas levantaba todo el stream a memoria...
    bits replaceFrom: 1
        to: bytes
        with: aStream contents
        startingAt: aStream position + 1.
    "
    aStream getBytesFor: bits.!  
createPolygonRgn: lppt cPoints: cPoints mode: fnPolyFillMode
    "Creates a polygonal region.
    The system closes the polygon automatically, if necessary,
        with a line from the last vertex to the first. "

    <api: CreatePolygonRgn struct long long ulongReturn>
    #addedByOStyle.
    ^self invalidArgument! 
realizePalette
    " Selects & Realize the receiver's palette.
    Returns the handle to the selected palette or nil if failed"

    | palette hDC changed hPalT |
    #addedByOStyle.

    hDC := self getDC.
    palette := self palette.
    palette notNil ifTrue: [
        (hPalT := GDILibrary selectPalette: hDC
            with: palette asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self osError ].
        (changed := GDILibrary realizePalette: hDC) = 16rFFFFFFFF
            ifTrue: [ ^self osError ].
        (GDILibrary selectPalette: hDC
            with: hPalT asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self osError ].
    ].
   self releaseDC: hDC.
    ^changed "Returns the number of entries that changed..."!   
readBitmapInfo: aStream
        "Private - Answer an instance of WinBitmapInfoHeader
         read from aStream . aStream position is updated.

    Modified by Ale for better bitmap info reading of non paletted bitmaps..."

    | bitmapInfo size rgb rgbTriple position byteArray coreHeader  count |
    position := aStream position.
    size := aStream nextULong.
    aStream position: position.
    size = 12
        ifTrue: [   "OS/2 1.2 format."
            coreHeader := SelfDefinedStructure named: 'OS2BITMAPCOREHEADER'.
            coreHeader contents
                replaceFrom: 1
                to: coreHeader contents size
                with: aStream contents
                startingAt: position + 1.
            position := position + size.
            rgbTriple := ByteArray new: ((1 bitShift: coreHeader bitCount) * 3).
            rgbTriple
                replaceFrom: 1
                to: rgbTriple size
                with: aStream contents
                startingAt: position + 1.
            position := position + rgbTriple size.
            bitmapInfo := WinBitmapInfoHeader
                width: coreHeader width
                height: coreHeader height
                planes: 1
                bitCount: (coreHeader bitCount * coreHeader planes).
            coreHeader bitCount = 24 ifFalse: [
                rgb := ByteArray new: ((1 bitShift: coreHeader bitCount) * 4).
                count := 0.
                1 to: rgbTriple size by: 3 do: [: i |
                    rgb at: i + count put: (rgbTriple at: i).
                    rgb at: i + 1 + count  put: (rgbTriple at: i + 1).
                    rgb at: i + 2 + count put: (rgbTriple at: i + 2).
                    rgb at: i + 3 + count put: 0.
                    count := count + 1]]]

        ifFalse: [  "Windows or OS/2 2.0 format."
            byteArray := ByteArray new: size.
            byteArray replaceFrom: 1
                to: size
                with: aStream contents
                startingAt: position + 1.
            position := position + size.
            bitmapInfo := WinBitmapInfoHeader fromBytes: (
                byteArray copyFrom: 1 to: WinBitmapInfoHeader sizeInBytes).
            bitmapInfo biSize: WinBitmapInfoHeader sizeInBytes.

            bitmapInfo bitCount = 24
                ifFalse: [
                    rgb := ByteArray new:  (
                            WinBitmapInfo
                                colorTableSize: bitmapInfo bitCount
                                clrUsed: bitmapInfo clrUsed). #modifiedByOStyle.
                    rgb replaceFrom: 1
                        to: rgb size
                        with: aStream contents
                        startingAt: position + 1.
                    position := position + rgb size ] ].

    bitmapInfo := WinBitmapInfo fromBytes: (
        rgb isNil
            ifTrue: [ bitmapInfo contents ]
            ifFalse: [ bitmapInfo contents, rgb ] ).
    aStream position: position.
    ^bitmapInfo! 
writePrivateProfileString: appName key: keyName str: str fileName: fname
    "Implemented By Ale..."
    <api: WritePrivateProfileStringA struct struct struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument

! 
allInstancesPrim
    " Reimplemented to collect all instances...
    We must do this because implementation of #startUp & #release
    invalidate the subclassification of Font.
    A better implementation of this methods can be as Icon class...
    Touched for class replacement..."

    | fonts |
    #addedByOStyle.
    self == Font ifFalse: [ ^super allInstancesPrim ].

    fonts := super allInstancesPrim. "collect real fonts..."
    self allSubclasses do: [:each|
        fonts := fonts , each allInstancesPrim
    ].
    ^fonts!
buildBasicMethodFor: selector in: aClass
    "Private - Build a basic method for a windows message...
     Returns true if successfull or yet exists..."

    | source result stream |
    #addedByOStyle.
    (aClass canUnderstand: selector) ifTrue: [ ^true ].
    Smalltalk isRunTime ifTrue: [^false].
    stream := ReadStream on: selector.
    source := WriteStream on: String new.
    source
        nextPutAll: (stream upTo: $:), ': wParam ', (stream upTo: nil), ' lParam';
        cr;nextPutAll: '    " Private - Attend the windows message ',selector,'."';
        cr;nextPutAll: '    #addedByOStyle.';
        cr;nextPutAll: '    ^nil'.
    source := source contents.
    result := aClass compile: source.
    result isNil ifFalse: [
        (Smalltalk at: #SourceManager) current
            logSource: source
            forSelector: result key
            inClass: aClass
    ].
    (Smalltalk at: #Transcript) cr;nextPutAll: 'Method generated: ',result value printString.
    ^result notNil!   
aditionalEvents
    "Private - Returns the aditional events for the receiver
    extracting them from aditionalEventsTable..."

    | set |
    #addedByOStyle.

    "detect WM_ registration needed..."
    (self unRegisteredMessage notNil
     and: [ self registerMessages not ])
    ifTrue: [
        ^self error: 'Can''t create ',self class name
            ,' because can''t register WM_messages'
    ].

    set := Set new.
    self aditionalEventsTable do: [:tuple|
        tuple size >= 3
        ifTrue: [ set add: (tuple at: 3) ]
    ].
    set remove: #none ifAbsent: [].
    ^set!
palette: aWinLogicalPalette
    " Private - Sets the receiver's palette."

    #addedByOStyle.
    ^self    propertyAt: #palette put: aWinLogicalPalette! 
execute: command
    "Private - Execute the DOS command line in command.
     Notify the user if an error has been signaled..."

    | result |

    result := KernelLibrary
        winExec: command asParameter
        cmdShow: SwShowminimized.

    result < 32 "An Error has occurred"
    ifTrue: [ self showExecError: result ].

    ^result!   
send: aSymbol to: aPane
    "Private - Send a Symbol message to aPane;
    The message will be send in deferred mode"

    (Message new
            receiver: aPane
            selector: aSymbol
            arguments: Array new ) performDeferred!  
defaultFont
    "Private - Returns the default font of the receiver"

    ^OSViewManager defaultFont.! 
beep
    "Private - Produces a Beep"

    UserLibrary messageBeep: 0!  
showExecError: anInteger
    "Private - An error loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Out of memory')
        (2  'File not found')
        (3  'Path not found')
        (5  'Attempt to dynamically link to a task')
        (6  'Library requires separate data segments for each task')
        (10 'Incorrect Windows version')
        (11 'Invalid .Exe file')
        (12 'OS/2 Application')
        (13 'DOS 4.0 Application')
        (14 'Unknown .Exe type')
        (15 'Attempt in protected (std or 386 enanced) mode to load
 an .Exe created for an earlier version of Windows.')
        (16 'Attempt to load a second instance of an .Exe
 containing multiple, writable data segments.')
        (17 'Attempt in large-frame EMS mode to load a
 second instance of an application that links to
 certain nonshareale DLLs already in use')
        (18 'Attempt in real mode to load an application
 marked for protected mode only')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'Error de ejecucin desconocido : ', anInteger printString].

    self
        beep;
        error: label! 
disable: aControl
    "Private - Disable a pane or more panes.
     aControl can be :
        1.- aPane to be disabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self disable: (Array with: aControl)].
    aControl do: [:each|
        self send: #disable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]!
enable: aControl when: aCondition
    "Private - Enable a pane or more panes when aCondition is met.
     aCondition can be aBoolean or a non parameter block to be evaluated.
    "
    | enable |
    enable := aCondition isBoolean
        ifTrue: [aCondition]
        ifFalse: [aCondition value].
    enable
    ifTrue: [ self enable: aControl ]
    ifFalse: [ self disable: aControl ]!  
profiler
    "Private - Returns the profiler for the receiver. Or nil..."

    | profiler |
    profiler := ARObject profiler.
    profiler applicationName: self class name.
    ^profiler!
openModeless
    "Private - Set the icon of the receiver and open the window"

    self mainView icon: self icon.
    super openModeless.!
openWindow
    "Private - Set the icon of the receiver and open the window"

    self mainView icon: self icon.
    super openWindow.!
enable: aControl
    "Private - Enable a pane or more panes.
     aControl can be :
        1.- aPane to be enabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self enable: (Array with: aControl)].
    aControl do: [:each|
        self send: #enable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]! 
getIconHeaderDIBits
        "Private - Get Device Independent Bitmap bits."
    | bitCount colorCount colors bitmapHeader bmapInfo size dibArchive |

    bitCount := bitmapInfo bitCount * bitmapInfo planes.

    ((bitmapInfo width ~= 32) or:
        [ (bitmapInfo height ~= 32) or:
            [ (bitCount ~= 4) ]]) ifTrue:[
            ^self error: 'Bitmap format not compatible with Icon'].

    size := ((bitmapInfo width * bitCount + 31) // 32 * 4) *
        bitmapInfo height.

    bitCount = 24
        ifTrue: [colorCount := 0]      "No color table for this format."
        ifFalse: [colorCount := (1 bitShift: bitCount) * 4].

    bitmapHeader := WinBitmapInfoHeader new.
    bitmapHeader
        biSize: 40;
        width: self width;
        height: self height;
        planes: 1;
        bitCount: bitCount;
        compression: BiRgb;
        sizeImage: size.
    colors := ByteArray new: colorCount.
    bmapInfo := bitmapHeader contents, colors.
    "Call getDIBits with nil to fill in the rest of bmapInfo."
    GDILibrary
        getDIBits: Display pen handle
        hBitmap: self handle
        startScan: 0
        scans: self height
        bits: nil
        bitsInfo: bmapInfo
        wUsage: DibRgbColors.
    "Call getDIBits with non nil to actually get the bits."
    dibArchive := ByteArray new: size.
    ( GDILibrary
        getDIBits: Display pen handle
        hBitmap: self handle
        startScan: 0
        scans: self height
        bitsStruct: dibArchive asParameter
        bitsInfo: bmapInfo
        wUsage: DibRgbColors ) = 0
            ifTrue: [ "please don't fail... ^self osError" #modifiedByOStyle. ].

    bmapInfo at: 9 put: 64.
    bmapInfo at: 21 put: 128.
    ^bmapInfo, dibArchive!  
bitmapInfo
    "Answer the bitmapInfo structure.
    Agregado por Ale para DIBImages..."

    #addedByOStyle.
    ^bitmapInfo!   
new
    "Returns an instance of the receiver initrialized"
    ^super new
        initialize;
        yourself!   
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
applicationName
    "Returns the instance var of the receiver
     for external manipulation"
    ^applicationName!
applicationName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    applicationName := anObject!   
at: aKey
    "Gets the value at aKey in the profile file.
     Default answer will nil..."
    | result count |
    result := (String new: maxProfileStringSize) asParameter.
    count := pathName isNil
    ifTrue: [ "Stored in Win.Ini"
        KernelLibrary
            getProfileString: applicationName asParameter
            keyName: aKey asParameter
            default: 'nil' asParameter
            returnedString: result size: result size
    ]
    ifFalse: [ "Stored in private Profile"
        KernelLibrary
            getPrivateProfileString: applicationName asParameter
            keyName: aKey asParameter
            default: 'nil' asParameter
            returnedString: result size: result size
            iniFileName: pathName asParameter
    ].

    result := result asStream next: count.
    result = 'nil' ifTrue: [^nil].

    ^result!
at: aKey put: anObject
    "Place anObject text representation in the profile file"
    | toStore |
    toStore := anObject isString
        ifTrue: [anObject]
        ifFalse: [anObject printString].
    ^pathName isNil
    ifTrue: [ "Store in Win.Ini"
        KernelLibrary
            writeProfileString: applicationName asParameter
            key: aKey asParameter
            str: toStore asParameter
    ]
    ifFalse: [ "Store in private Profile"
        KernelLibrary
            writePrivateProfileString: applicationName asParameter
            key: aKey asParameter
            str: toStore asParameter
            fileName: pathName asParameter
    ]!   
at: aKey ifAbsent: aBlock
    "Gets the value at aKey in the profile file.
     If the element does not exist then returns aBlock value..."
    | result |
    result := self at: aKey.
    ^result isNil
        ifTrue: [aBlock value]
        ifFalse: [result]!
compiler
    "Private - Returns the Compiler support class."

	^Smalltalk at: #Compiler
		ifAbsent: [
			self
				checkBound: 'vdev31w'; "development support"
				yourself.
			Smalltalk at: #Compiler
		]! 
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! 
objectAt: aKey
    "Gets the value at aKey in the profile file
       evaluated using the compiler.
     Default answer will nil..."
    | evalBlock |
    evalBlock := [:source|
        source isNil
            ifTrue: [nil]
            ifFalse:[self compiler evaluate: source]
    ].
    ^ evalBlock value: (self at: aKey)!
initialize
    "Private - Initializes the receiver"

    "Initialize the maximum size spected for profile strings"
    maxProfileStringSize := 2048.
    applicationName := 'OStyle'.!   
keys
    "Gets aList of key names in the profile file
     associated to the current applicationName."
    | result count stream line |
    result := (String new: maxProfileStringSize) asParameter.
    count := pathName isNil
    ifTrue: [ "Stored in Win.Ini"
        KernelLibrary
            getProfileString: applicationName asParameter
            keyName: nil
            default: '' asParameter
            returnedString: result size: result size
    ]
    ifFalse: [ "Stored in private Profile"
        KernelLibrary
            getPrivateProfileString: applicationName asParameter
            keyName: nil
            default: '' asParameter
            returnedString: result size: result size
            iniFileName: pathName asParameter
    ].

    stream := (result asStream next: count) asStream.
    result   := OrderedCollection new.
    [stream atEnd] whileFalse: [
        line := stream upTo: 0 asCharacter.
        line isEmpty ifFalse: [result add: line]
    ].

    ^result asArray!
openInstances
    "Private - Returns the currently open ViewManagers
    that are instances of the receiver... "

    | cole |
    cole := Set new.
    Notifier windows do: [:each|
        (each isApplicationWindow
            and: [ each owner isKindOf: self ])
        ifTrue: [ cole add: each owner ]
    ].
    ^cole asArray!  
defaultFont
    "Private - Returns the default font of the receiver"
    | defaultFont |
    defaultFont := self atKey: #defaultFont.
    defaultFont isNil ifFalse: [^defaultFont].
    defaultFont := "Font new
        fromBytes:
            #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97
                 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )."
        Font face: 'Arial' size: 6@8 fixedWidth: false.
    self atKey: #defaultFont put: defaultFont.
    ^defaultFont!   
play: aSoundName
    "Private - Produces the sound named aSoundName.
     aSoundName can be a fileName
        or the name of an Win.Ini [Sounds] entry "

    MMSystemDLL library
        sndPlaySound:  aSoundName asParameter
        flags: 0! 
profiler
    "Private - Returns the profiler for the receiver."

    | profiler |
    profiler := ARObject profiler.
    profiler applicationName: self name.
    ^profiler!
resourceModule
    " Private - Returns the module for resources..."

    ^ARObject resourceModule! 
open
    "Creates an instance of the receiver and opens it..."

    ^self new open!
writeProfileString: appName key: keyName str: str
    "Implemented By Ale..."
    <api: WriteProfileStringA struct struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument
!
constructEventsTriggered
        "Private - answer the set of events that instances of the
        receiver can trigger."
    ^super constructEventsTriggered
        add: #eraseBackground ;
        add: #button1Up ;
        add: #button1Down ;
        add: #button1DownShift ;
        add: #button1Moved ;
        add: #button1UpShift ;
        add: #button2DoubleClicked ;
        add: #button2Down ;
        add: #button2Moved ;
        add: #clicked: ;
        add: #doubleClicked ;
        add: #mouseMoved ;
        add: #mouseMove ;
        yourself! 
wmPaletteIsChanging: wParam with: lParam
    " Private - Attend the windows message wmPaletteIsChanging:with:.
    The WM_PALETTEISCHANGING message informs applications that an
    application is going to realize its logical palette.
    If an application processes this message, it should return zero.
    Comments:
        The application changing its palette does not wait for acknowledgment
     of this message before changing the palette and sending the
     WM_PALETTECHANGED message. As a result, the palette may already
     be changed by the time an application receives this message.
    If the application either ignores or fails to process this message and
     a second application realizes its palette while the first is using palette
     indices, there is a strong possibility that the user will see unexpected
     colors during subsequent drawing operations.
    "

    #addedByOStyle.
    self triggerEvent: #paletteIsChanging.
    ^nil!   
withColor: aColor
    "Returns an instance of the receiver set with aColor"

    | dialog |
    dialog := self basicNew.
    dialog initialize: aColor.
    ^dialog!
initialize: aColor
    "Private - Initialize the receiver's chooseFontStruct."

    | rgb |
    rgb := aColor notNil ifTrue: [ aColor asRGBColor asInteger ] ifFalse: [0].

    "simulate Window>>#initialize"
    self handle: WindowHandle nullValue.

    "simulate FontDialog>>#initialize"
    chooseFontStruct :=  (SelfDefinedStructure named: 'CHOOSEFONT').
    chooseFontStruct
        lStructSize: chooseFontStruct sizeInBytes;
        rgbColors: rgb;
        yourself.
    self sampleForeColor: aColor.
    self style: CfInittologfontstruct | CfEffects | CfScreenfonts!   
bits: aByteArray
    "Sets the receiver's bits.
    Agregado por Ale para DIBImages..."

    #addedByOStyle.
    bits := aByteArray! 
printOn: aStream
    "Print a textual description of the receiver on <aStream>.
    Added by Ale for more descriptive printing..."

    #addedByOStyle.
    aStream
        "nextPutAll: self class name;"
        space;
        nextPut: ${;
        nextPutAll: self red printString;
        nextPutAll: ',';
        nextPutAll: self green printString;
        nextPutAll: ',';
        nextPutAll: self blue printString;
        nextPutAll: ',';
        nextPutAll: self flags printString;
        nextPut: $}!   
wmQueryNewPalette: wParam with: lParam
    " Private - Attend the windows message wmQueryNewPalette:with:.
    The WM_QUERYNEWPALETTE message informs an application
     that it is about to receive the input focus, giving the application an
     opportunity to realize its logical palette when it receives the focus.
    An application should return nonzero if it realizes its logical palette;
     otherwise, it should return zero.
    "

    | hPal |
    #addedByOStyle.
    self triggerEvent: #queryNewPalette.

    (hPal := self realizePalette) notNil
    ifTrue: [
        "self isTopPane ifFalse: [" self invalidateRect: nil.  "]."
        ^hPal
    ].
    ^nil!
stopTimers
    "Private - End sthe timer in use for the receiver...
    See comments in message #tick... "

    | timers |
    timers := self timers copy.
    [timers isEmpty] whileFalse: [ timers removeFirst stop ].!   
asterisk
    "Private - Produces an asterisk sound"

    self play:  'SystemAsterisk'! 
beep
    "Private - Produces a Beep"

    UserLibrary messageBeep: 0!  
startTimerEach: milliseconds
    "Private - Start a Timer for milliseconds in the receiver.
    See comments in message #tick... "

    | timer timers |
    timer := Timer new.
    timer
        period: milliseconds;
        when: #ticked send: #tick to: self;
        start;
        yourself.
    self timers add: timer.
    !   
helpOn: aPane
    "Private - Attends general helps"

    | hm |
    hm := self mainView helpManager.
    hm isNil
    ifFalse: [ hm displayHelpKey: self class name ].! 
timers
    " Private - returns current timers in use..."

    ^self mainView
        propertyAt: #timers
        ifAbsentPut: [ OrderedCollection new ]! 
fileExit
    "Private - Implemented by Ale for commodity..."

    self close!  
enable: aControl
    "Private - Enable a pane or more panes.
     aControl can be :
        1.- aPane to be enabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self enable: (Array with: aControl)].
    aControl do: [:each|
        self send: #enable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]! 
send: aSymbol to: aPane
    "Private - Send a Symbol message to aPane;
    The message will be send in deferred mode"

    (Message new
            receiver: aPane
            selector: aSymbol
            arguments: Array new ) performDeferred!  
defaultFont
    "Private - Returns the default font of the receiver"
    ^self class defaultFont!   
play: aSoundName
    "Private - Produces the sound named aSoundName.
     aSoundName can be a fileName
        or the name of an Win.Ini [Sounds] entry "

    ^self class play: aSoundName! 
profiler
    "Private - Returns the profiler for the receiver..."
    ^self class profiler! 
enable: aControl when: aCondition
    "Private - Enable a pane or more panes when aCondition is met.
     aCondition can be aBoolean or a non parameter block to be evaluated.
    "
    | enable |
    enable := aCondition isBoolean
        ifTrue: [aCondition]
        ifFalse: [aCondition value].
    enable
    ifTrue: [ self enable: aControl ]
    ifFalse: [ self disable: aControl ]!  
disable: aControl
    "Private - Disable a pane or more panes.
     aControl can be :
        1.- aPane to be disabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self disable: (Array with: aControl)].
    aControl do: [:each|
        self send: #disable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]!
openWindow
    "Private - Set the icon of the receiver and open the window."

    self mainView when: #closed send: #stopTimers.
    super openWindow.!   
initialize
    "Private - Initializes the receiver"
    super initialize.
    self
        title: '&Help';
        selector: #helpOnKey:
            "For non symbol selectors use
            the helpOnKey: symbol. For more
             detail look at Menu #selector: message"!  
buildWindow: menuBar
        "Private - Build the host system side of the menu for the receiver.
         Set the id field for each menu item.
         The id is two bytes. First byte is the number
         assigned to the menu.  Second byte is the
         ordinal number of the item.  Thus ensuring unique ids
         across all the menus in a window.
         Answer the MenuItem for the receiver."
    | menuNumber a |
    menuNumber := menuBar newSubMenuFor: self.
    menuNumber isNil ifTrue: [^nil].
    menuItem := MenuItem new
        id: (menuNumber * 256) + 1;
        contents: 'TempText';
        submenu: self;
        style: MfString + MfPopup + MfHelp;
        yourself.
    1 to: items size do: [:i|
        self buildItem: i menu: menuNumber menuBar: menuBar].
    ^menuItem! 
fromModule:aFileName name: anId
    "Answer an Icon object. aFileName is a DLL file name anId can be a string or an Integer.
    Returns a valid icon, or nil."
    | icon |

    #addedByOStyle.
    anId isNil ifTrue: [^nil].
    (anId isString and: [anId isEmpty]) ifTrue: [^nil].
    icon := self fromModule: aFileName id: anId.
    icon handle = Icon runtimeIcon handle
    ifTrue: [ icon release. ^nil ] ifFalse: [ ^icon ].! 
stopRecording
    "Close the receiver.
    Modified by Ale for non failures."
    ( hMetaFile := GDILibrary closeMetaFile: deviceContext ) = 0
        ifTrue: [ "^self osError"#modifiedByOStyle ]!  
matchOf: aString
    "Answer a Fraction that describes the degree of the match.
    Zero is no match at all.
    One is the best match possible.
    A bonus is awarded if the length of the two strings is within 2 characters."

    | i j k minSize bonus|
    #addedByOStyle.
    minSize := (j := self size)
        min: (k := aString size).
    self == aString
        ifTrue: [^1].
    minSize = 0 ifTrue: [^0].
    bonus := (j - k) abs < 2
        ifTrue: [1] ifFalse: [0].
    i := 1.
    [i <= minSize and:
        [(self at: i) asUpperCase
         = (aString at: i) asUpperCase]]
            whileTrue: [i := i + 1].
    [j > 0 and: [k > 0 and:
        [(self at: j) asUpperCase
        = (aString at: k) asUpperCase]]]
            whileTrue: [j := j - 1.
                k := k - 1].
    ^(i - 1 + self size - j
        + bonus) / (2 * minSize + bonus)! 
execute: commandLine
    "Private - Execute the command line..."

    ^self
        execute: commandLine
        mode: SwShownormal! 
registrationDatabase
    " Private - Returns the RegistrationDatabase class.
    If not present try to bind it from file..."

    ^Smalltalk at: #RegistrationDatabase
        ifAbsent: [
            "try to bound external suport..."
            SmalltalkLibraryBinder attemptBindTo: 'VREG3AW'.
            Smalltalk at: #RegistrationDatabase ifAbsent: [
                self error: 'Soporte de registracin no encontrado. Instale nuevamente este producto.'
            ]
        ]!  
run: commandLine mode: aSwMode
    "Private - Run the command line...
    Command line can be an executable or an associated file..."

    ^self
        execute: (self commandLineFor: commandLine)
        mode: aSwMode! 
errorBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    errorBlock := anObject! 
execute: commandLine mode: aSwMode
    "Private - Execute the command line..."
    | result |
    commandLine size = 0 ifTrue: [ ^false ].
    result := KernelLibrary
        winExec: commandLine asParameter
        cmdShow: aSwMode.

    result < 32 "An Error has occurred"
    ifTrue: [
        errorBlock notNil ifTrue: [ errorBlock value: result ].
        ^false
    ].

    ^true!  
parametersFrom: aString and: commandLine
    "Private - Returns the command line for aString"

    | parameters line index char stream |

    stream := ReadStream on: commandLine.
    parameters := aString asArrayOfSubstrings.
    index := 0.
    line := WriteStream on: String new.
    [stream atEnd] whileFalse: [
        char := stream next.
        char = $% ifTrue: [ "process parameter..."
            index := stream nextWord asInteger.
            (index between: 1 and: parameters size)
            ifTrue: [
                line nextPutAll: (parameters at: index).
                parameters at: index put: nil.
            ].
        ]
        ifFalse: [ line nextPut: char ].
    ].
    parameters do: [:remaining|
        remaining notNil ifTrue: [ line nextPutAll: ' ',remaining ]
    ].
    ^line contents! 
errorBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^errorBlock!  
verb: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    verb := anObject! 
run: commandLine
    "Private - Run the command line...
    Command line can be an executable or an associated file..."

    ^self run: commandLine mode: SwShownormal!   
showError: anInteger
    "Private - An erro loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Memoria insuficiente')
        (2  'Archivo no encontrado')
        (3  'Archivo no encontrado')
        (5  'Atentado de linkeo dinamico a un programa')
        (6  'La libreria requiere distintos segmentos para ejecutarse')
        (10 'Versin incorrecta de sistema operativo')
        (11 'Archivo ejecutable de formato invlido.')
        (12 'Aplicacin de Sistema Operativo OS/2')
        (13 'Aplicacin de Sistema Operativo DOS 4.0')
        (14 'Formato de ejecutable desconocido')
        (15 'El programa no fu diseado para trabajar en modo protegido.')
        (16 'El programa no puede cargarse ms de una vez.')
        (17 'El programa no puede cargarse ms de una vez.')
        (18 'Aplicacin no preparada para correr en modo protegido')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'UnKnown Exec error : ', anInteger printString].
    ^self error: label!   
ddeClientClass
    " Private - Returns the DDEClient class.
    If not present try to bind it from file..."

    ^Smalltalk at: #DDEClient
        ifAbsent: [
            "try to bound external suport..."
            SmalltalkLibraryBinder attemptBindTo: 'VDDE3AW'.
            Smalltalk at: #DDEClient ifAbsent: [
                self error: 'Soporte de DDE no encontrado. Instale nuevamente este producto.'
            ]
        ]!  
verb
    "Returns the instance var of the receiver
     for external manipulation"
    ^verb!  
ddeExecute: root arguments: params
    "Private - Execute the program associated to root with params
    using a DDE system channel..."
    | dde application topic ddeExec ddeClientClass |
    ddeExec := (self registrationDatabase new at: root,'\ddeexec' ifAbsent: [^false]) value.
    ddeExec := self parametersFrom: params and: ddeExec.

    topic := (self registrationDatabase new at: root,'\ddeexec\topic' ifAbsent: ['System']) asString.
    application := (self registrationDatabase new at: root,'\ddeexec\application'
        ifAbsent: [
        application := self registrationDatabase new at: root,'\command'.
        application := (application reversed upTo: $\) reversed upTo: $.
        ]) asString.

    ddeClientClass := self ddeClientClass.
    dde := ddeClientClass newClient: nil application: application topic: topic.
    dde isNil ifTrue: [ ^false ].
    dde
        executeCommand: ddeExec;
        terminate.
    ^true!  
initialize
    " Private - Initialize the receiver."

    super initialize.
    errorBlock := [:err| self showError: err ].
    verb := 'open'. "default verb for registration command"! 
commandLineFor: aString
    "Private - Returns the command line for aString"

    | stream prologue extension epilogue root registry
      executables batchFiles commandLine |
    executables := #('exe' 'com' ).
    batchFiles := #('bat' ).

    stream := ReadStream on: aString.
    stream atEnd ifTrue: [^nil].
    prologue := String new.
    [ #($. $ ) includes: stream peek ]
    whileFalse: [
        prologue := prologue , (String with: stream next).
        stream atEnd ifTrue: [ ^aString ]
    ].
    extension := stream next = $.
        ifTrue: [ stream nextWord asLowerCase ]
        ifFalse: [ 'exe' ].

    epilogue := stream upTo: nil.
    extension size = 0 ifTrue: [ ^aString ].

    (executables includes: extension) ifTrue: [ ^aString ].
    (batchFiles includes: extension) ifTrue: [ self warning: 'batch file...',aString. ^aString ].

    registry := self registrationDatabase new.
    (registry includesKey: '.avi')
    ifFalse: [ ^self error: 'La extensin ".',extension,'" no esta asociada a ningn programa.' ].

    registry := self registrationDatabase new at: '.',extension,'\shell\',self verb ifAbsent: [].
    registry notNil ifTrue: [
        (registry includesKey: 'command') ifTrue: [
            ^self parametersFrom: aString and: (registry at: 'command') value
        ].
        (registry includesKey: 'ddeexec') ifTrue: [
            (self ddeExecute: '.',extension,'\shell\',self verb arguments: aString)
            ifTrue: [^nil].
            ^self error: 'La extensin ".',extension,'" no est correctamente asociada.'
        ].
    ].

    root := (self registrationDatabase new at: '.',extension) value.
    root size = 0 ifTrue: [
            ^self error: 'La extensin ".',extension,'" no est correctamente asociada.'
    ].

    registry := self registrationDatabase new at: root,'\shell\',self verb ifAbsent: [].
    registry notNil ifTrue: [
        (registry includesKey: 'command') ifTrue: [
            ^self parametersFrom: aString and: (registry at: 'command') value
        ].
        (registry includesKey: 'ddeexec') ifTrue: [
            (self ddeExecute: '.',extension,'\shell\',self verb arguments: aString)
            ifTrue: [^nil].
            ^self error: 'La extensin ".',extension,'" no est correctamente asociada.'
        ].
    ].

    ^self error: 'La extensin ".',extension,'" no est correctamente asociada.'! 
palette
    " Private - Returns the receiver's working palette."

    #addedByOStyle.
    ^self
        propertyAt: #palette
        ifAbsent: [
            self
                triggerEvent: #needsPalette;
                propertyAt: #palette
                ifAbsent: []
        ]!
registerAsStartUpObject
    "Private - Initialize the receiver for save image notification"

    (Smalltalk includesKey: #SessionModel)
    ifTrue: [
        (Smalltalk at: #SessionModel) current
            removeActionsWithReceiver: self forEvent: #aboutToSaveImage;
            when: #aboutToSaveImage send: #aboutToSaveImage to: self;
            yourself
    ]!   
pathName: aPathName
    "Returns the real path for aPathName..."

    ^self locationFor: aPathName!
locations
    "Returns locations of root directories.
    PathFinder locations
    "

    ^self new locations!   
locationFor: path
    "Returns the full path name for path...
    Expands Location macros...
    Returns the path or nil..."

    ^self new locationFor: path!   
aboutToSaveImage
    "Private - The Smalltalk image is being saved.
     Force Locations to be reloaded upon startUp
    PathFinder aboutToSaveImage
    "

    self reset! 
reset
    "Private - Force Locations to be reloaded...
    PathFinder reset
    "

    Locations := nil.!
locationFor: path
    "Private - Returns the full path name for path...
    Expands Location macros...
    Returns the path or nil..."

    | stream result root |
    result := String new.
    stream := ReadStream on: path.
    [stream atEnd] whileFalse: [
        result := result , (stream upTo: self locationStartCharacter).
        stream atEnd
        ifFalse: [
            root := stream upTo: self locationEndCharacter.
            root trimBlanks isEmpty
            ifFalse: [
                root = 'Disk'
                ifTrue: [ root := Disk drivePathName ]
                ifFalse: [
                root := self locations
                    at: root asLowerCase
                    ifAbsent: [
                        MessageBox warning: 'Ruta de archivos no encontrada >>',root,
                            '\\Verifique el archivo de configuracin ' withCrs,self profiler pathName,
                                '\Seccin ['withCrs,self class name,']'.
                        ^nil
                    ]. "root entry not found"
                    ].
                result := result , root.
            ]
        ]
    ].

    (result includes: self locationStartCharacter) ifTrue: [ "be recursive..."
        ^self locationFor: result
    ].

    ^result! 
locationStartCharacter
    "Private - returns the character used for mark location start."
    ^${! 
getLocations
    "Private - Read file root locations from profiler."

    | profiler root |
    self class registerAsStartUpObject.
    Locations := Dictionary new.
    profiler := self profiler.
    profiler keys do: [:key|
        root := (profiler at: key) trimBlanks.
        root isEmpty
        ifFalse: [ Locations at: key asLowerCase put: root ]
    ].!  
locationEndCharacter
    "Private - returns the character used for mark location end."
    ^$}! 
locations
    "Private - Returns locations of root directories."

    Locations notNil ifTrue: [^Locations].
    self getLocations.
    ^Locations!  
wmPaletteChanged: wParam with: lParam
    " Private - Attend the windows message wmPaletteChanged:with:.
    The WM_PALETTECHANGED message is sent to all top-level
     and overlapped windows after the window with the input focus
     has realized its logical palette, thereby changing the system
     palette. This message allows a window without the input
     focus that uses a color palette to realize its logical palette
     and update its client area.
   Should return zero if it processes this message.
    To avoid creating an infinite loop, a window that receives this message
     must not realize its palette, unless it determines that wParam does
     not contain its own window handle.
    "

    #addedByOStyle.
    self handle = (WindowHandle fromInteger: wParam) ifTrue: [ ^nil ].
"
    Transcript cr;show: self handle asString,'=',(WindowHandle fromInteger: wParam) asString.
"
    self triggerEvent: #paletteChanged.
    ^self wmQueryNewPalette: wParam with: lParam! 
constructEventsTriggered
        "Private - answer the set of events that instances of the
        receiver can trigger."

    #modifiedByOStyle. "for aditional events support..."
    ^super constructEventsTriggered
        add: #dragSourceNeedsObject: ;
        add: #dragSourceNeedsCursors: ;
        add: #dragSourceCut: ;
        add: #dragTargetNeedsOperations: ;
        add: #dragTargetEnter: ;
        add: #dragTargetLeave: ;
        add: #dragTargetOver: ;
        add: #dragTargetDrawEmphasis: ;
        add: #dragTargetEraseEmphasis: ;
        add: #dragTargetDrop: ;
        addAll: self aditionalEvents;
        yourself!  
mouseLocation
        "Answer the mouse location as of the last
         mouse input event received."
    ^mouse dpToLp: graphicsTool handle!  
mouseMove: aPoint
        "Private - Mouse has moved to aPoint.
        Let the owner process the event."
    mouse := aPoint.
    self
        event: #mouseMove;
       triggerEvent: #mouseMoved "with: aPoint."with: self.! 
button1DoubleClick: aPoint
        "Private - button 1 has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button1DoubleClick.
    self triggerEvent: #doubleClicked!   
button1UpShift: aPoint
        "Private - Button 1 has been released with shift key down.
        Let the owner process the event."
    handle = WindowHandle queryCapture ifFalse: [ ^self ].
    self clearMouseCapture.
    mouse := aPoint.
    self event: #button1UpShift.
    self triggerEvent: #button1UpShift!   
button2DoubleClick: aPoint
        "Private - button 2 has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button2DoubleClick.
    self triggerEvent: #button2DoubleClicked!
button2Up: aPoint
        "Private - button 2 has been released.
        Let the owner process the event or
        finish the right button scrolling."
    mouse := aPoint.
    self clearMouseCapture.
    ( ( self handlesEvent: #button2Up )
    or: [ self hasActionForEvent: #rightClicked ] )
        ifTrue: [
            self event: #button2Up.
            self triggerEvent: #rightClicked ]
        ifFalse: [ super button2Up: aPoint ]!
button1Up: aPoint
        "Private - Left button has been released.
        Let the owner process the event."
    super button1Up: aPoint.
    handle = WindowHandle queryCapture ifFalse: [ ^self ].
    self clearMouseCapture.
    mouse := aPoint.
    self event: #button1Up.
    self triggerEvent: #clicked: with: aPoint! 
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    | oldDC backColor |
    self minimized ifTrue: [ ^1 ].     "Do not erase background while minimized"
    self graphicsTool isNil ifTrue: [ ^nil ].

    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.

   backColor := self backColor.
    backColor isNil ifTrue: [ backColor := self defaultBackColor ].
      graphicsTool backColor: backColor.

    self
        triggerEvent: #eraseBackground
        withArguments: (Array with: self)
        ifNotHandled: [ graphicsTool erase ].

    graphicsTool handle: oldDC.
    ^1!   
button1Move: aPoint
        "Private - button 1 is down and the
        mouse has been moved.
        Let the owner process the event."
    self isLocalDragSource ifTrue: [ ^super button1Move: aPoint ].

    handle = WindowHandle queryCapture ifFalse: [ ^self ].
    mouse := aPoint.
    self event: #button1Move.
    self triggerEvent: #button1Moved!  
button2Move: aPoint
        "Private - button 2 is down and the
        mouse has been moved.
        Let the owner process the event."
    self isLocalDragSource ifTrue: [ ^super button2Move: aPoint ].

    mouse := aPoint.
    self event: #button2Move.
    self triggerEvent: #button2Moved!  
button1Down: aPoint
        "Private - Left button has been pressed down.
        Let the owner process the event."
    (super button1Down: aPoint) ifFalse: [^ self].
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1Down.
    self triggerEvent: #button1Down.!
button2Down: aPoint
        "Private - button 2 has been pressed down.
        Let the owner process the event
        or do the right button scrolling."
    mouse := aPoint.
    ( ( self handlesEvent: #button2Down )
    or: [ self hasActionForEvent: #button2Down ] )
        ifTrue: [
            self event: #button2Down.
            self triggerEvent: #button2Down ]
        ifFalse: [ super button2Down: aPoint ]!   
button1DownShift: aPoint
        "Private - Left button and shift key are both down.
        Let the owner process the event."
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1DownShift.
    self triggerEvent: #button1DownShift!
excludeRegion: region1Handle from: region2Handle
    "Answer region2Handle with region1Handle excludded from it.
    Implememnted by Ale..."

    #addedByOStyle.
    ( GDILibrary combineRgn: region2Handle
        srcRgn1: region2Handle
        srcRgn2: region1Handle
        mode: RgnDiff ) = 0
            ifTrue: [ ^self osError ].
    ^region2Handle!   
palette
    "Returns the receiver's palette..."

    | logPalette |
    #addedByOStyle.
    self bitCount > 8 ifTrue: [ ^nil ].
    logPalette := WinLogicalPalette fromWinLogPalette: (
        WinLogPalette fromRgbColor: bitmapInfo colorTable).
    ^logPalette! 
openTutorial
    "Open the Tutorial..."

    (applicationWindow owner respondsTo: #openTutorial)
    ifTrue: [ applicationWindow owner openTutorial ]!
printRegisterForm
    "Prints a Registration Form"

    (applicationWindow owner respondsTo: #printRegisterForm)
    ifTrue: [ applicationWindow owner printRegisterForm ]!   
tipOfTheDay
    "Lets the user vew the tips of the day dialog"

    (Smalltalk at: #LogoView ifAbsent: [^nil]) new open.!  
helpMenu
    "Private - Answer the Help menu."
    ^HelpMenu new
        owner: self;
        title: 'A&yudas';
        selector: nil;
        appendItem: '&Indice...    F1' selector: #displayHelpIndex accelKey: VkF1 accelBits: AfVirtualkey;
        appendItem: '&Buscar ayuda sobre...    Alt+F1' selector: #searchHelpOn accelKey: VkF1 accelBits: AfVirtualkey|VkControl ;
        appendItem: 'Ayuda de &pantalla...    Shift+F1' selector: #helpPick;
        appendSeparator;
        appendItem: '&Como usar las ayudas...' selector: #displayHelpForHelp;
        appendItem: 'Curso &Tutorial' selector: #openTutorial;
        appendSeparator;
        appendItem: 'T&ruco del dia...' selector: #tipOfTheDay;
        appendSeparator;
        appendItem: '&Orden de compra...' selector: #printOrderForm;
        appendItem: '&Registracin...' selector: #printRegisterForm;
        appendItem: '&Soporte Tcnico...' selector: #technicalSupport;
        appendSeparator;
        appendItem: '&Acerca de la Agenda...' selector: #about;
        yourself!  
helpPick
    "Sets the receiver in helpMode..."

   self turnOnHelpMode!   
printOrderForm
    "Prints an Order Form"

    (applicationWindow owner respondsTo: #printOrderForm)
    ifTrue: [ applicationWindow owner printOrderForm ]!  
technicalSupport
    "Display the technicalSupport dialog"

    (applicationWindow owner respondsTo: #technicalSupport)
    ifTrue: [ applicationWindow owner technicalSupport ]! 
about
    "Private - Open a dialog window to show the product information."
    aboutDlgClass isNil
    ifTrue: [ (Smalltalk at: #AboutApp ifAbsent: [^super about]) new open ]
    ifFalse: [ super about ]! 
asDIB
	"Returns aDIB obtained from the receiver."

    #addedByOStyle.
	^DIB new
		bitmapInfo: self bitmapInfo deepCopy;
		bits: self getDIBits;
		yourself!   
colorTableSize: bitCount clrUsed: clrUsed
    "Private - Answer the size of the color table.
    Added By Ale for better bitmap reading..."

    #addedByOStyle.
    clrUsed = 0 ifTrue: [ ^self colorTableSize: bitCount ].
    bitCount <= 8 ifTrue: [  ^clrUsed * 4  ].
    ^self colorTableSize: bitCount! 
bitmapInfo: aWinBitmapInfo
    "Sets the bitmapInfo structure.
    Agregado por Ale para DIBImages..."

    #addedByOStyle.
    bitmapInfo := aWinBitmapInfo.!   
new
    "Answer a new instance of the receiver.
    Touched for class replacement..."

    #modifiedByOStyle.
    self == Font "now we create OSFont instances..."
    ifTrue: [ ^OSFont new ].

    ^super new initialize!   
colorTable: aByteArray
    "Set the color table of the structure to be aByteArray.
    Patched by Ale for less colors replacement support..."

    | stream |
    #modifiedByOStyle.
    "
    self contents
        replaceFrom: WinBitmapInfoHeader sizeInBytes + 1
        to: self size
        with: aByteArray
    "
    stream := WriteStream on: self contents.
    stream position: WinBitmapInfoHeader sizeInBytes.
    stream nextPutAll: aByteArray!
fromStream: aStream
    "Answer an instance of Bitmap copied from aStream.
     aStream must be in DIB format.
    Implemented By Ale..."

    #addedByOStyle.
    ^(DIB fromStream:aStream) asBitmap!  
unRegisteredMessage
    "Private - Returns one unregisterd message or nil."

    | index |
    #addedByOStyle.
    ^self aditionalEventsTable
        detect: [:one|
            index := one first.
              index > 0 and: [
                (index between: 1 and: OperatingSystemEvents size)
                   ifTrue: [ (OperatingSystemEvents at: index) isNil ]
                ifFalse: [ (OperatingSystemEventsExtra includesKey: index) not ]
            ]
        ] ifNone: []!   
bits
    "Answer the bits.
    Agregado por Ale para DIBImages..."

    #addedByOStyle.
    ^bits!   
registerMessages
    "Private - Register aditional messages.
     Returns true if successfull..."

    | msgTable index |
    #addedByOStyle.
    msgTable := self aditionalEventsTable.
    msgTable do: [:tuple|
        index := tuple first.
        index > 0
        ifTrue: [
            (((index between: 1 and: OperatingSystemEvents size)
                and: [ (OperatingSystemEvents at: index) isNil ])
              or: [(OperatingSystemEventsExtra includesKey: index) not])
            ifTrue: [ "Must be registered..."
                (self buildBasicMethodFor: (tuple at: 2) in: Window) ifFalse: [^false].
                (self buildBasicMethodFor: (tuple at: 2) in: self) ifFalse: [^false].
                (index between: 1 and: OperatingSystemEvents size)
                ifTrue: [ OperatingSystemEvents at: index put: (tuple at: 2) ]
                ifFalse: [ OperatingSystemEventsExtra at: index put: (tuple at: 2) ].
            ]
        ]
    ].

    ^true!   
patternFill: aRectangle rule: aRopConstant
        "Private - Fill aRectangle with the current brush pattern
         using aRopConstant.
    Touched by Ale for no error report..."

    self allHandles do: [ :h |
        ( GDILibrary
            patBlt: h
            x: aRectangle origin x
            y: aRectangle origin y
            width: aRectangle width
            height: aRectangle height
            rop: aRopConstant )
                ifFalse: [ "^self osError"#modifiedByOStyle. ] ]!
palette
    "Returns the receiver's palette..."

    #addedByOStyle.
    palette notNil ifTrue: [ ^palette ].
    palette := self createDIBPalette.
    ^palette!